#ifndef	_CRI_ADXF_H_INCLUDED
#define	_CRI_ADXF_H_INCLUDED
/****************************************************************************/
/*																			*/
/*			$title$ `cwt@CVXe Cu						*/
/*				ADXF (ADX File System) Library								*/
/*																			*/
/*			Copyright (c) 1998 CSK Research Institute						*/
/*				1998.7.3		written by S.Hosaka							*/
/*																			*/
/****************************************************************************/

/****************************************************************************/
/*      CN[ht@C												*/
/****************************************************************************/

/****************************************************************************/
/*	萔}N																*/
/****************************************************************************/

/* Copyright */
							/*              1         2         3        4 */
							/*    1234567890123456789012345678901234567890 */
							/*    +++++++++++++++++++++++++++++++++        */
#define	ADXF_CPY_STR			("Copyright (c) 1998 CRI")
#define	ADXF_CPY_SIZ			(32) 

/* Version */
							/*              1         2         3        4 */
							/*    1234567890123456789012345678901234567890 */
							/*    +++++++++++++++++++++++++++++++++        */
#define	ADXF_VER_STR			("ADXF Version 5.30")
#define	ADXF_VER_SIZ 			(32)


/* őp[eBV */
#define	ADXF_PART_MAX			(256)
/* őt@C */
#define	ADXF_FILE_MAX			(65536)
/*	ADXFnhIuWFNǧ	*/
#define	ADXF_OBJ_MAX			(16)

/* $define$ nh̏(ADXF_STAT_`) */
#define	ADXF_STAT_STOP			(1)					/* ~				*/
#define ADXF_STAT_READING		(2)					/* f[^ǂݍݒ		*/
#define ADXF_STAT_READEND		(3)					/* f[^ǂݍݏI	*/
#define ADXF_STAT_ERROR			(4)					/* ǂݍ݃G[	*/

/* $define$ V[N^Cv(ADXF_SEEK_`) */
#define	ADXF_SEEK_SET			(0)					/* t@C̐擪		*/
#define ADXF_SEEK_CUR			(1)					/* ݂̈ʒu			*/
#define ADXF_SEEK_END			(2)					/* t@C̏I[		*/

/* $define$ G[R[h */
#define	ADXF_ERR_OK				(0)					/* I				*/
#define	ADXF_ERR_FATAL			(-1)				/* ÕG[			*/
#define	ADXF_ERR_INTERNAL		(-2)				/* ̃G[			*/
#define	ADXF_ERR_PRM			(-3)				/* sȃp[^		*/
#define	ADXF_ERR_AFS_FILE		(-4)				/* sAFSt@C	*/

/* l */
#define	ADXF_DEF_SCT_SIZE		(2048)				/* CD-ROM̃ZN^TCY	*/
#define	ADXF_DEF_DMA_ALIGN		(32)				/* DMÃACg	*/

/****************************************************************************/
/*	񋓒萔																*/
/****************************************************************************/

/****************************************************************************/
/*	}N																*/
/****************************************************************************/

/* p[eBVɕKvȗ̈̌vZ */
#define	ADXF_PTIF_CMN_SZ			(5*sizeof(long))

#define	ADXF_CALC_PTINFO_REAL_SIZE(n)	\
								(ADXF_PTIF_CMN_SZ+(((n)+1)*sizeof(short)))

#define	ADXF_CALC_PTINFO_SIZE(n)	\
					((ADXF_CALC_PTINFO_REAL_SIZE(n)+sizeof(short))/4*4)

#define	ADXF_CALC_ADD_PTINFO_SIZE(n)	\
					(ADXF_PTIF_CMN_SZ+((n)*(2*sizeof(short)+sizeof(long))))

/****************************************************************************/
/*	f[^^																*/
/****************************************************************************/

#ifndef ADXSTM_DEFINED
#define ADXSTM_DEFINED
typedef void *ADXSTM;
#endif

#ifndef SJ_DEFINED
#define SJ_DEFINED
typedef void *SJ;
#endif

/*	$data$ ADXFnh (ADXF)	*/
#ifndef ADXF_DEFINED
#define	ADXF_DEFINED
typedef	struct _adx_fs {
	char	used;						/*	gpۂ				*/
	char	stat;						/*	nh̏				*/
	char	sjflag;						/*	Oݒ肳ꂽSJۂ	*/
	char	rev;						/*	\̈					*/
	ADXSTM	stm;						/*	ADXSTMnh				*/
	SJ		sj;							/*	Xg[WCg		*/
	long	fad;						/*	t@CAhX			*/
	long	fnsct;						/*	t@CTCY(ZN^)		*/
	long	fsize;						/*	t@CTCY(oCg)		*/
	long	skpos;						/*	ANZX|C^̈ʒu		*/
	long	rdstpos;					/*	ǂݍ݊Jnʒu			*/
	long	rqsct;						/*	ǂݍݗvf[^(ZN^)*/
	long	rdsct;						/*	ǂݍ񂾃f[^(ZN^)	*/
} ADX_FS;
typedef	ADX_FS	*ADXF;
#endif

/* p[eBV */
#ifndef ADXF_PTINFO_DEFINED
#define ADXF_PTINFO_DEFINED
typedef struct _adxf_ptinfo {
	struct _adxf_ptinfo	*next;		/*	̃p[eBV(NULL:IWi)	*/
	long				size;		/*	p[eBV̈TCY		*/
	long				fad;		/*	p[eBV̐擪FAD				*/
	long				nfile;		/*	p[eBṼt@C		*/
	unsigned short		nentry;		/*	p[eBV̓o^t@C	*/
	char				type;		/*	IWiǋL̃tO			*/
	char				rev;		/*	\̈							*/
	long				top;		/*	t@C̐擪					*/
} ADXF_PTINFO;
#endif

/* ǋLt@C̏ */
#ifndef ADXF_ADD_DEFINED
#define ADXF_ADD_DEFINED
typedef struct _adxf_add_info {
	unsigned short	flid;			/*	t@CID							*/
	unsigned short	fnsct;			/*	t@CTCY						*/
	long			ofst;			/*	ItZbg							*/
} ADXF_ADD_INFO;
#endif


/****************************************************************************/
/*	ϐ錾																*/
/****************************************************************************/

/****************************************************************************/
/*	֐̐錾																*/
/****************************************************************************/

/*===========================================================================
		$group$ CȕƏI
  ===========================================================================*/

/* $func$ Cȕ
 * [@] void	ADXF_Init( void );
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] CuB
 */
void ADXF_Init(void);

/* $func$ CȕI
 * [@] void ADXF_Finish(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] CȕIB
 */
void ADXF_Finish(void);

/* $func$ p[eBṼ[h
 * [@] long ADXF_LoadPartition(long ptid, char *fname, 
 *													void *ptinfo, long nfile);
 * [@] ptid	:p[eBVID
 *			fname	:AFSt@C̖O
 *			ptinfo	:p[eBVǂݍݗ̈
 *			nfile	:t@C
 * [o@] Ȃ
 * [֐l] G[R[h
 * [@@\] AFSt@Cp[eBVIDɐݒ肷B
 */
long ADXF_LoadPartition(long ptid, char *fname, void *ptinfo, long nfile);

/* $func$ p[eBV̒ǉ
 * [@] long ADXF_AddPartition(long ptid, char *fname, 
 *													void *ptinfo, long nfile);
 * [@] ptid	:p[eBVID
 *			fname	:AFSt@C̖O
 *			ptinfo	:p[eBVǂݍݗ̈
 *			nfile	:t@C
 * [o@] Ȃ
 * [֐l] G[R[h
 * [@@\] AFSt@Cp[eBVIDɒǉݒ肷B
 */
long ADXF_AddPartition(long ptid, char *fname, void *ptinfo, long nfile);

/* $func$ p[eBVTCY̎擾
 * [@] long ADXF_GetPtinfoSize(long ptid);
 * [@] ptid	:p[eBVID
 * [o@] Ȃ
 * [֐l] p[eBVTCY(PʁFoCg)
 * [@@\] p[eBV̈̃TCY擾B
 */
long ADXF_GetPtinfoSize(long ptid);

/*===========================================================================
		$group$ t@C̓ǂݍ
  ===========================================================================*/

/*	$func$ t@C̃I[v(ISO9660̃t@C)
 * [@] ADXF ADXF_Open(char *fname, void *atr);
 * [@] fname	: t@C
 *			atr		: t@C̑
 * [o@] Ȃ
 * [֐l] ADXFnhAG[̏ꍇNULL
 * [@@\] w̃t@CI[vAADXFnhԂB
 */
ADXF ADXF_Open(char *fname, void *atr);

/*	$func$ t@C̃I[v(AFStH[}bg)
 * [@] ADXF ADXF_OpenAfs(long ptid, long flid);
 * [@] ptid	: p[eBVID
 *			flid	: t@CID
 * [o@] Ȃ
 * [֐l] ADXFnhAG[̏ꍇNULL
 * [@@\] p[eBVIDƃt@CIDŎw肳ꂽAFSt@CI[vA
 *			ADXFnhԂB
 */
ADXF ADXF_OpenAfs(long ptid, long flid);

/* $func$ t@C̃N[Y
 * [@] void ADXF_Close(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] w肳ꂽADXFnhN[YB
 */
void ADXF_Close(ADXF adxf);

/* $func$ SJւ̃f[^ǂݍ݊Jn
 * [@] void ADXF_ReadSj32(ADXF adxf, long nsct, SJ sj);
 * [@] adxf	: ADXFnh
 *			nsct	: ǂݍ݃f[^̗(PʁFZN^)
 *			SJ		: Xg[WCg
 * [o@] Ȃ
 * [֐l] ǂݍ݃f[^(PʁFZN^)
 * [@@\] Xg[WCgɃf[^ǂݍ݂̃NGXg𔭍sB
 *			Xg[WCg̃obt@TCÝAZN^̐{łȂ
 *			ȂȂB
 *			Xg[WCg烆[Uf[^ǂݏoƁAIɃXg[ *			WCgɃf[^ǂݏoB
 *			NGXgANZX삪ƁAANZX|C^
 *			nsctZN^iށB
 */
long ADXF_ReadSj32(ADXF adxf, long nsct, SJ sj);

/* $func$ f[^̓ǂݍ݊Jn
 * [@] void ADXF_ReadNw32(ADXF adxf, long nsct, void *buf);
 * [@] adxf	: ADXFnh
 *			nsct	: ǂݍ݃f[^̗(PʁFZN^)
 *			buf		: ǂݍݗ̈
 * [o@] Ȃ
 * [֐l] ǂݍ݃f[^(PʁFZN^)
 * [@@\] f[^ǂݍ݂̃NGXg𔭍sB
 *			NGXgANZX삪ƁAANZX|C^
 *			nsctZN^iށB
 */
long ADXF_ReadNw32(ADXF adxf, long nsct, void *buf);

/* $func$ f[^̓ǂݍݒ~
 * [@] long ADXF_Stop(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] ~_ł̃ANZX|C^̈ʒu
 * [@@\] f[^̓ǂݍ݂𒆎~B
 */
long ADXF_Stop(ADXF adxf);

/* $func$ T[o֐
 * [@] void ADXF_ExecServer(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ԂXVB
 */
void ADXF_ExecServer(void);

/*===========================================================================
		$group$ ANZX|C^̐
  ===========================================================================*/

/* $func$ ANZX|C^̈ړ
 * [@] long ADXF_Seek(ADXF adxf, long pos, long type);
 * [@] adxf	: ADXFnh
 *			pos		: ANZX|C^̈ړ(PʁFZN^)
 *			type	: ړ(V[N^CvFADXF_SEEK_`)
 * [o@] Ȃ
 * [֐l] ANZX|C^̈ʒuA̒l̓G[R[h
 * [@@\] ANZX|C^typeposZN^ꂽʒuɈړB
 */
long ADXF_Seek(ADXF adxf, long pos, long type);

/* $func$ ANZX|C^̎擾
 * [@] long ADXF_Tell(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] ANZX|C^̈ʒu
 * [@@\] ANZX|C^̈ʒu擾B
 */
long ADXF_Tell(ADXF adxf);

/*===========================================================================
		$group$ ̎擾
  ===========================================================================*/

/* $func$ t@CTCY̎擾
 * [@] long ADXF_GetFsizeSct(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] t@CTCY(PʁFZN^)
 * [@@\] w肳ꂽt@C̃TCYZN^PʂŎ擾B
 */
long ADXF_GetFsizeSct(ADXF adxf);

/* $func$ t@CTCY̎擾
 * [@] long ADXF_GetFsizeByte(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] t@CTCY(PʁFoCg)
 * [@@\] w肳ꂽt@C̃TCYoCgPʂŎ擾B
 */
long ADXF_GetFsizeByte(ADXF adxf);

/* $func$ ǂݍݗv̎擾
 * [@] long ADXF_GetNumReqSct(ADXF adxf, long *seekpos);
 * [@] adxf	: ADXFnh
 * [o@] seekpos	: ǂݍ݈ʒu
 * [֐l] vǂݍ݃f[^(PʁFZN^)
 * [@@\] vǂݍ݈ʒuƃf[^ʂ擾B
 */
long ADXF_GetNumReqSct(ADXF adxf, long *seekpos);

/* $func$ ۂɓǂݍ񂾃ZN^̎擾
 * [@] long ADXF_GetNumReadSct(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] ǂݍ񂾃f[^(PʁFZN^)
 * [@@\] ۂɓǂݍ񂾃f[^ʂ擾B
 */
long ADXF_GetNumReadSct(ADXF adxf);

/* $func$ nh̏Ԃ̎擾
 * [@] long ADXF_GetStat(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] ADXFnh̓(ԁFADXF_STAT_`)
 * [@@\] ADXFnh̓Ԃ擾B
 */
long ADXF_GetStat(ADXF adxf);

/* $func$ FADƃt@CTCY̎擾
 * [@] long ADXF_GetAfsRange(long ptid, long flid, 
 *													long *fad, long *fnsct);
 * [@] ptid	: p[eBVID
 *			flid	: t@CID
 * [o@] fad		: t@CAhX
 *			nsct	: t@CTCY(P:ZN^)
 * [֐l] G[R[h
 * [@@\] p[eBṼt@C̃t@CAhXƃTCY擾B
 */
long ADXF_GetFileRange(long ptid, long flid, long *fad, long *fnsct);

#endif	/* _CRI_ADXF_H_INCLUDED */
