/*
 *  Middleware Library
 *  Copyright (c) 1998 SEGA
 *  
 *		Middleware Play
 *
 *  Module  : Library Header File
 *  File    : sfd_mw.h
 *  Create  : 1998-07-25
 *  Modify  : 1998-10-27
 *  Note    :
 */

#ifndef	_SFD_MW_H_
#define	_SFD_MW_H_

/*	Version No.	*/
#define	MWD_SFD_VER	"1.10"

/*
 *		Middleware library function for Sofdec
 */

/***********************************************************************
 *      CN[ht@C
 ***********************************************************************/

/***********************************************************************
 *      萔}N
 ***********************************************************************/

/* Sofdec Error */
#define	MWD_PLY_ERR_SFD_INIT	(-301)
#define	MWD_PLY_ERR_SFD_NOTYPE	(-302)
#define	MWD_PLY_ERR_SFD_ERRFN	(-303)
#define	MWD_PLY_ERR_SFD_FINISH	(-304)
#define	MWD_PLY_ERR_SFD_CREATE	(-305)
#define	MWD_PLY_ERR_SFD_DSTRY	(-306)
#define	MWD_PLY_ERR_SFD_START	(-307)
#define	MWD_PLY_ERR_SFD_STOP	(-308)

/* t@C^Cv */
#define	MWD_PLY_FTYPE_NON		(0)
#define	MWD_PLY_FTYPE_SFD		(1)
#define	MWD_PLY_FTYPE_MPV		(2)

/* fR[_^Cv */
#define	MWD_DECTYP_NON			(0)
#define	MWD_DECTYP_SOFDEC		(1)

/* GSCnhő吔 */
#define	MWD_GSCHN_MAX			(1)

/*	\ʒuETCỸftHg^Cv	*/
#define MWD_PLY_DTYPE_AUTO	(0)
#define MWD_PLY_DTYPE_FULL	(1)

/***********************************************************************
 *      񋓒萔
 ***********************************************************************/

/***********************************************************************
 *      }N
 ***********************************************************************/

/*	I[fBIo̓obt@	*/
#define	MWD_SFD_CALC_WORK_AUDIO_OUT(nch)	(0x2020*sizeof(short)*(nch)+32)
/*	I[fBIo̓obt@	(ftHglj*/
#define	MWD_SFD_CALC_WORK_AUDIO_OUT0	MWD_SFD_CALC_WORK_AUDIO_OUT(2)
/*	I[fBI̓obt@	*/
#define	MWD_SFD_CALC_WORK_AUDIO_IN			(36*2048+32)
/*	I[fBIpobt@TCY	*/
#define	MWD_SFD_SIZE_WORK_AUDIO(nch)	( \
				MWD_SFD_CALC_WORK_AUDIO_OUT0 + \
				MWD_SFD_CALC_WORK_AUDIO_IN \
			)

/* QƗpt[obt@ */
#define	MWD_SFD_CALC_WORK_RFB(wc, hc, wy, hy)	\
								SFD_RFB_BUF_SIZ((wc), (hc), (wy), (hy))
/* QƗpt[obt@ (ftHgl)	*/
#define	MWD_SFD_CALC_WORK_RFB0 \
				MWD_SFD_CALC_WORK_RFB(	SFD_RFB_WIDTH_C, \
										SFD_RFB_HEIGHT_C, \
										SFD_RFB_WIDTH_Y, \
										SFD_RFB_HEIGHT_Y )

/* o͗pt[obt@ */
#define	MWD_SFD_CALC_WORK_TAB(wy, hy, nfrm)	\
								SFD_TA_BUF_SIZ((wy), (hy), (nfrm))
/* o͗pt[obt@ (ftHgl)	*/
#define MWD_SFD_CALC_WORK_TAB0	\
				MWD_SFD_CALC_WORK_TAB(SFD_RFB_WIDTH_Y, SFD_RFB_HEIGHT_Y, 4)

#define	MWD_SFD_CALC_WORK(sx, sy, nch)	\
		MWD_SFD_CALC_WORK_AUDIO(2) +	\
		
/*	[NTCY	*/
#define	MWD_SFD_SIZE_WORK		(0x00300000)


/***********************************************************************
 *      f[^^̐錾
 ***********************************************************************/

/* sofdec */
typedef struct {
	Sint32		ftype;			/* ĐXg[̎		*/
	Sint32		hnmax;			/* őnh				*/
	Sint32		vsync_mhz;		/* VSYNCgiHz1,000{)	*/
	Sint32		disp_latency;	/* \CeV (2/3)			*/
} MWS_PLY_INIT_SFD;

typedef struct {
	Bool	first_hpel;			/* n[ty̍ ON/OFF */
} MWS_PLY_OPT_SFD;

/* creating parameter	*/
typedef struct {
	MWS_PLY_OPT_SFD	opt;
	Sint32	ftype;			/*	ĐXg[̎ 				*/
	Sint32  dtype;			/*	\ʒuETCỸftHg^Cv		*/
	Sint32	lx;				/*	\ʒu ( X W)						*/
	Sint32	ly;				/*	\ʒu ( Y W)						*/
	Sint32	sx;				/*	\TCY	(X )					*/
	Sint32	sy;				/*	\TCY	(Y )					*/
	Sint8	*work;			/*	[N̈								*/
	Sint32	wksize;			/*	[N̈TCY						*/
} MWS_PLY_CPRM_SFD;

/***********************************************************************
 *		ϐ̐錾
 ***********************************************************************/

/***********************************************************************
 *      ֐̐錾
 ***********************************************************************/

/*	VXȅ@(sbInitSystem̑OɌĂԊ֐)	*/
void mwPlyPreInitSofdec(void);

/* initialize Sofdec library */
void mwPlyInitSofdec(MWS_PLY_INIT_SFD *iprm);

/*	finish using Sofdec library */
void mwPlyFinishSofdec(void);

/* create MWPLY handle for Sofdec */
MWPLY mwPlyCreateSofdec(MWS_PLY_CPRM_SFD *cprm);

/*	n[y̐ݒ	*/
void mwPlySetFastHalfpel(MWPLY mwply, Sint32 sw);

/*	o͏̐ݒ	*/
void mwPlySetAudioSw(MWPLY mwply, Sint32 sw);

/*	\ʒu̐ݒ	*/
void mwPlySetDispPos(MWPLY mwply, float lx, float ly);

/*	\TCY̐ݒ	*/
void mwPlySetDispSize(MWPLY mwply, float sx, float sy);

/*	Px̐ݒ	(val= 0`255) */
void mwPlySetBright(MWPLY mwply, Sint32 val);

#endif	/*	_SFD_MW_H_	*/
