/*
 *  Shinobi Library
 *  Copyright (c) 1998 SEGA
 *
 *       Peripheral
 *
 *  Module  : Library Header File
 *  File    : sg_pad.h
 *  Create  : 1998-03-25
 *  Modify  : 1998-11-26
 *  Version : 1.08
 *  Note    :
 */

#ifndef _SG_PAD_H_
#define _SG_PAD_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <sg_xpt.h>

/*
 *  DEFINES / MACROS
 */

/******** |[gԍ萔 ***************************************************/
#define PDD_PORT_A0    0                   /* |[gA0                     */
#define PDD_PORT_A1    1                   /* |[gA1                     */
#define PDD_PORT_A2    2                   /* |[gA2                     */
#define PDD_PORT_A3    3                   /* |[gA3                     */
#define PDD_PORT_A4    4                   /* |[gA4                     */
#define PDD_PORT_A5    5                   /* |[gA5                     */
#define PDD_PORT_B0    6                   /* |[gB0                     */
#define PDD_PORT_B1    7                   /* |[gB1                     */
#define PDD_PORT_B2    8                   /* |[gB2                     */
#define PDD_PORT_B3    9                   /* |[gB3                     */
#define PDD_PORT_B4   10                   /* |[gB4                     */
#define PDD_PORT_B5   11                   /* |[gB5                     */
#define PDD_PORT_C0   12                   /* |[gC0                     */
#define PDD_PORT_C1   13                   /* |[gC1                     */
#define PDD_PORT_C2   14                   /* |[gC2                     */
#define PDD_PORT_C3   15                   /* |[gC3                     */
#define PDD_PORT_C4   16                   /* |[gC4                     */
#define PDD_PORT_C5   17                   /* |[gC5                     */
#define PDD_PORT_D0   18                   /* |[gD0                     */
#define PDD_PORT_D1   19                   /* |[gD1                     */
#define PDD_PORT_D2   20                   /* |[gD2                     */
#define PDD_PORT_D3   21                   /* |[gD3                     */
#define PDD_PORT_D4   22                   /* |[gD4                     */
#define PDD_PORT_D5   23                   /* |[gD5                     */

/******** foCXID *******************************************************/
#define PDD_DEV_NODEVICE       0x00000000  /* foCXڑ               */
#define PDD_DEV_CONTROLLER     0x000f06fe  /* WRg[             */
#define PDD_DEV_KEYBOARD       0x01020000  /* {92L[L[{[h       */

/******** {^Eo[T|[g ***************************************/
#define PDD_DEV_SUPPORT_AY2   (1 << 21)    /* AiOY2           */
#define PDD_DEV_SUPPORT_AX2   (1 << 20)    /* AiOX2           */
#define PDD_DEV_SUPPORT_AY1   (1 << 19)    /* AiOY1           */
#define PDD_DEV_SUPPORT_AX1   (1 << 18)    /* AiOX1           */
#define PDD_DEV_SUPPORT_AL    (1 << 17)    /* AiOL            */
#define PDD_DEV_SUPPORT_AR    (1 << 16)    /* AiOR            */
#define PDD_DEV_SUPPORT_KRB   (1 << 15)    /* fW^\L[BE    */
#define PDD_DEV_SUPPORT_KLB   (1 << 14)    /* fW^\L[B    */
#define PDD_DEV_SUPPORT_KDB   (1 << 13)    /* fW^\L[B    */
#define PDD_DEV_SUPPORT_KUB   (1 << 12)    /* fW^\L[B    */
#define PDD_DEV_SUPPORT_TD    (1 << 11)    /* D{^                */
#define PDD_DEV_SUPPORT_TX    (1 << 10)    /* X{^                */
#define PDD_DEV_SUPPORT_TY    (1 <<  9)    /* Y{^                */
#define PDD_DEV_SUPPORT_TZ    (1 <<  8)    /* Z{^                */
#define PDD_DEV_SUPPORT_KR    (1 <<  7)    /* fW^\L[AE    */
#define PDD_DEV_SUPPORT_KL    (1 <<  6)    /* fW^\L[A    */
#define PDD_DEV_SUPPORT_KD    (1 <<  5)    /* fW^\L[A    */
#define PDD_DEV_SUPPORT_KU    (1 <<  4)    /* fW^\L[A    */
#define PDD_DEV_SUPPORT_ST    (1 <<  3)    /* X^[g{^         */
#define PDD_DEV_SUPPORT_TA    (1 <<  2)    /* A{^                */
#define PDD_DEV_SUPPORT_TB    (1 <<  1)    /* B{^                */
#define PDD_DEV_SUPPORT_TC    (1 <<  0)    /* C{^                */

/******** {^萔 *******************************************************/
#define PDD_DGT_TL    (1 << 17)            /* L{^(G~[V)    */
#define PDD_DGT_TR    (1 << 16)            /* R{^(G~[V)    */
#define PDD_DGT_KRB   (1 << 15)            /* fW^\L[BE          */
#define PDD_DGT_KLB   (1 << 14)            /* fW^\L[B          */
#define PDD_DGT_KDB   (1 << 13)            /* fW^\L[B          */
#define PDD_DGT_KUB   (1 << 12)            /* fW^\L[B          */
#define PDD_DGT_TD    (1 << 11)            /* D{^                      */
#define PDD_DGT_TX    (1 << 10)            /* X{^                      */
#define PDD_DGT_TY    (1 <<  9)            /* Y{^                      */
#define PDD_DGT_TZ    (1 <<  8)            /* Z{^                      */
#define PDD_DGT_KR    (1 <<  7)            /* fW^\L[AE          */
#define PDD_DGT_KL    (1 <<  6)            /* fW^\L[A          */
#define PDD_DGT_KD    (1 <<  5)            /* fW^\L[A          */
#define PDD_DGT_KU    (1 <<  4)            /* fW^\L[A          */
#define PDD_DGT_ST    (1 <<  3)            /* X^[g{^               */
#define PDD_DGT_TA    (1 <<  2)            /* A{^                      */
#define PDD_DGT_TB    (1 <<  1)            /* B{^                      */
#define PDD_DGT_TC    (1 <<  0)            /* C{^                      */

/******** G[萔 *******************************************************/
#define PDD_ERR_OK       0x00000000        /* G[Ȃ                   */
#define PDD_ERR_RETRY    0xff0000fc        /* Transmit Againɂ郊gC */
#define PDD_ERR_GENERIC  0xff000000        /* `G[                 */

/******** _[h萔 ***************************************************/
#define PDD_PLOGIC_ACTIVE    0             /* _(ftHg)           */
#define PDD_PLOGIC_NEGATIVE  1             /* _                       */

/******** Maple [h萔 *************************************************/
#define PDD_MODE_TYPE_A      1             /* Maple^CvA(SET4p)         */
#define PDD_MODE_TYPE_B      0             /* Maple^CvB(SET5ȍ~p)     */


/*
 *  PERIPHERAL INFO
 */

/******** ytF^Cv ***********************************************/
#define PDD_DEVTYPE_CONTROLLER   (1 << 0)  /* WRg[             */
#define PDD_DEVTYPE_STORAGE      (1 << 1)  /* Xg[W                   */
#define PDD_DEVTYPE_LCD          (1 << 2)  /* LCD                          */
#define PDD_DEVTYPE_TIMER        (1 << 3)  /* ^C}                       */
#define PDD_DEVTYPE_SOUNDINPUT   (1 << 4)  /*                      */
#define PDD_DEVTYPE_ARGUN        (1 << 5)  /* AR-Gun                       */
#define PDD_DEVTYPE_KEYBOARD     (1 << 6)  /* L[{[h                   */
#define PDD_DEVTYPE_LIGHTGUN     (1 << 7)  /* Light-Gun                    */
#define PDD_DEVTYPE_VIBRATION    (1 << 8)  /* UfoCX                 */

/******** GAR[h *****************************************************/
#define PDD_DEVAREA_USA          (1 << 0)  /* kAJn               */
#define PDD_DEVAREA_JAPAN        (1 << 1)  /* {n                     */
#define PDD_DEVAREA_ASIA         (1 << 2)  /* AWAn                   */
#define PDD_DEVAREA_EUROPE       (1 << 3)  /* [bpn               */
#define PDD_DEVAREA_RESERVED1    (1 << 4)  /* \n1                    */
#define PDD_DEVAREA_RESERVED2    (1 << 5)  /* \n2                    */
#define PDD_DEVAREA_RESERVED3    (1 << 6)  /* \n3                    */
#define PDD_DEVAREA_RESERVED4    (1 << 7)  /* \n4                    */

/******** RlN^̌ ***************************************************/
#define PDD_CONDIR_TOPSIDE       0         /*                            */
#define PDD_CONDIR_BOTTOMSIDE    1         /*                            */
#define PDD_CONDIR_LEFTSIDE      2         /*                            */
#define PDD_CONDIR_RIGHTSIDE     3         /* E                           */


/*
 *  TYPEDEFS
 */

/******** ytF\ *******************************************/
typedef struct {
	Uint32 type;                /* ytF̃^Cv                    */
	Uint32 reserved[3];         /* \                                    */
	Uint8 is_root;              /* [gfoCXǂ\            */
	Uint8 area_code;            /* GAR[h                            */
	Uint8 connector_dir[2];     /* RlN^̌                          */
	char product_name[32];      /* i                                  */
	char license[64];           /* CZX                              */
	Uint16 stdby_pow;           /* X^oCd                      */
	Uint16 max_pow;             /* őd                            */
} PDS_PERIPHERALINFO;

/******** ytFf[^\ *****************************************/
typedef struct {
	Uint32 id;                            /* foCXID                    */
	Uint32 support;                       /* {^̃T|[g          */
	Uint32 on;                            /* ݉Ă{^        */
	Uint32 off;                           /* ݕĂ{^        */
#ifdef USE_UNION
	union {
		Uint32 push;                      /* ݉ꂽuԂɂ{^  */
#endif
		Uint32 press;
#ifdef USE_UNION
	};
#endif
#ifdef USE_UNION
	union {
		Uint32 pull;                      /* ݕꂽuԂɂ{^  */
#endif
		Uint32 release;
#ifdef USE_UNION
	};
#endif
	Uint16 r;                             /* f[^R     (     0`255  ) */
	Uint16 l;                             /* f[^L     (     0`255  ) */
	Sint16 x1;                            /* f[^X1    (  -128`127  ) */
	Sint16 y1;                            /* f[^Y1    (  -128`127  ) */
	Sint16 x2;                            /* f[^X2    (  -128`127  ) */
	Sint16 y2;                            /* f[^Y2    (  -128`127  ) */
	char* name;                           /* foCX                  */
	void* extend;                         /* gf[^AhX            */
	Uint32 old;                           /* \                          */
	PDS_PERIPHERALINFO* info;             /* ytFւ̃|C^  */
} PDS_PERIPHERAL;


void pdInitPeripheral(Sint32 logic, void* recvbuf, void* sendbuf);
void pdExitPeripheral(void);
void pdExecPeripheralServer(void);
const PDS_PERIPHERAL* pdGetPeripheral(Uint32 port);
Sint32 pdGetPeripheralError(Uint32 port);
const PDS_PERIPHERALINFO* pdGetPeripheralInfo(Uint32 port);
void pdSetMode(Sint32 mode);
Sint32 pdGetMode(void);
void pdSetOptimize(Uint32 count);
Uint32 pdGetOptimize(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _SG_PAD_H_ */
