/*
 *  Shinobi Library
 *  Copyright (c) 1998 SEGA
 *
 *       Keyboard
 *
 *  Module  : Library Header File
 *  File    : sg_pdkbd.h
 *  Create  : 1998-03-25
 *  Modify  : 1998-06-05
 *  Version : 1.06
 *  Note    :
 */

#ifndef _SG_PDKBD_H_
#define _SG_PDKBD_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <sg_xpt.h>
#include <sg_pad.h>


/*
 *  DEFINES / MACROS
 */

/******** L[rbgATC ********************************************/
#define PDD_KEY_CTRL_RGUI     (1 << 7)     /* EGUI                         */
#define PDD_KEY_CTRL_RALT     (1 << 6)     /* EALT                         */
#define PDD_KEY_CTRL_RSHIFT   (1 << 5)     /* EVtg                      */
#define PDD_KEY_CTRL_RCTRL    (1 << 4)     /* ERg[                */
#define PDD_KEY_CTRL_LGUI     (1 << 3)     /* GUI                         */
#define PDD_KEY_CTRL_LALT     (1 << 2)     /* ALT                         */
#define PDD_KEY_CTRL_LSHIFT   (1 << 1)     /* Vtg                      */
#define PDD_KEY_CTRL_LCTRL    (1 << 0)     /* Rg[                */

/******** LED_ *******************************************************/
#define PDD_LED_SHIFT         (1 << 7)     /* Vtg                        */
#define PDD_LED_POWER         (1 << 6)     /* d                          */
#define PDD_LED_KANA          (1 << 5)     /* Ji                          */
#define PDD_LED_SCRLOCK       (1 << 2)     /* Scroll Lock                   */
#define PDD_LED_CAPLOCK       (1 << 1)     /* Caps Lock                     */
#define PDD_LED_NUMLOCK       (1 << 0)     /* Num Lock                      */

/*
 *  TYPEDEFS
 */

/******** L[{[hf[^\ *******************************************/
typedef struct {
	Uint8 ctrl;                           /* L[̏                */
	Uint8 led;                            /* LED̓_                 */
	Uint8 key[6];                         /* ĂL[R[h        */
} PDS_KEYBOARD;

#if 0
/******** L[{[h\ *********************************************/
typedef struct {
	Uint8 lang;                           /* L[{[h                */
	Uint8 type;                           /* L[{[h^Cv              */
	Uint8 reserved[2];                    /* \                          */
} PDS_KEYBOARDINFO;
#endif

typedef struct {
	Uint8 used;
	Uint8 rate;
	Uint8 delay;
	Uint8 rate_count;
	Uint8 delay_count;
	Uint8 repeat_flag;
	Uint8 predata;
	Uint8 old_data[8];
	Uint32 port;
	Uint32 putp;
	Uint32 getp;
	Uint8* buf;
	Uint32 bufsize;
} PDS_KBDSTRUCT;

typedef PDS_KBDSTRUCT* PD_KBD;



/*
 *  PROTOTYPES
 */

/******** ჌xL[{[h֐ *******************************************/
#if 0
const PDS_KEYBOARDINFO* pdKbdGetInfo(Uint32 port);
#endif
const PDS_KEYBOARD* pdKbdGetData(Uint32 port);

#if 0
/******** xL[{[h֐ *******************************************/
void pdKbdInit(void);
void pdKbdSetState(PD_KBD hKbd, Uint8 rate, Uint8 delay);
void pdKbdGetState(PD_KBD hKbd, Uint8* rate, Uint8* delay);
Sint32 pdKbdIsHit(PD_KBD hKbd);
PD_KBD pdKbdCreate(Uint32 port);
void pdKbdDestroy(PD_KBD kbd);
char pdKbdGetc(PD_KBD hKbd);
void pdKbdExecServer(void);
void pdKbdExecServerOne(PD_KBD hKbd);
#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _SG_PDKBD_H_ */
