/*
 *   GDFS Streaming sample
 *   
 *   version 0.50  1998/10/29
 */


/***** constants *****/


#define STR_SCTSIZE  2048
#define STR_BYTE2SCT(x)  ((x) >> 11)
#define STR_SCT2BYTE(x)  ((x) << 11)


enum fStrErr {
	STR_ERR_INIT = -50,
	STR_ERR_MEMOVER,
	STR_ERR_ILGHNDL,
	STR_ERR_SEEK,
	STR_ERR_EOF,
	STR_OK = 0
};


/***** structures *****/


typedef struct fStrBuf {
	Sint32 total; /* obt@OőZN^ */
	Sint32 back; /* ߂\ZN^ */
	Sint32 readlmt; /* ǂݍ݋E */
	void *buf; /* obt@ւ̃|C^ (32 bytes align) */
} StrBuf;


typedef struct fStrHandle {
	Sint32 total; /* obt@OőZN^ */
	Sint32 back; /* ߂\ZN^ */
	Sint32 readlmt; /* ǂݍ݋E */
	void *buf; /* obt@ւ̃|C^ (32 bytes align) */
	Sint32 bufsize; /* obt@̃oCgTCY */
	Sint32 filesize; /* t@CTCY */
	Sint32 cur; /* ݂̃obt@̓ǂݏoʒu */
	Sint32 top; /* obt@̐擪 */
	Sint32 bottom; /* obt@̍Ō */
	GDFS hn; /* ǂݍݗpnh */
	Sint32 rdsct; /* ǂݍݒ̃ZN^ */
	Sint32 trnsed; /* ]ς݃oCg */
} StrHandle;

typedef StrHandle *STRHN;


typedef struct fStrWork {
	Sint32 max_stream; /* ő哯I[v */
	StrHandle *strhandle;
} StrWork;


/*** APIs ***/


Sint32 StrInit(Sint32 max_stream, StrBuf *strbuf);
void StrFinish(void);
STRHN StrOpen(const char *fname, GDFS_DIRREC dirrec);
STRHN StrOpenNum(Sint32 strnum, const char *fname, GDFS_DIRREC dirrec);
Sint32 StrFread(void *ptr, Sint32 size, Sint32 n, STRHN hn);
Sint32 StrFseek(STRHN hn, Sint32 offset, Sint32 whence);
Sint32 StrFeof(STRHN hn);
Sint32 StrClose(STRHN hn);

void StrServer(void);

void *StrGetPtr(STRHN hn);
Sint32 StrGetContSize(STRHN hn);


/* eof */
