/*
 *			ADXT TvvO No.2
 *				(Đ & CfbNXĐ)
 */

#include	<math.h>
#include	<string.h>

#include	"cri_adxf.h"
#include	"cri_adxt.h"

/***
*		`
***/

/*	Đő`l	*/
#define	MAX_CH			(2)
/*	ōTvOg	*/
#define	MAX_SFREQ		(44100)
/*	őADXTnh	*/
#define	MAX_ADXT		(4)

/***
*		TEh̏
***/

#include	"shinobi.h"
#include	"sg_sd.h"

/* TEhhCo̓]E */
Void	sound_init(Void *ptr)
{
	SDMEMBLK	memblk = NULL;

	/*	Initialize Sound library	 */
	sdLibInit(NULL, 0, 0);		/*	This api's argument is dummy now.  */

	/* 	Download and Initialize Sound driver.	 */
	/*	Create Memory block handle  */
	sdMemBlkCreate(&memblk);
	/*  Setting Memoby block handle  */
	sdMemBlkSetPrm(memblk, ptr, 0, SDD_MEMBLK_SYNC_FUNC, NULL);
	/*	Initialize Sound driver  */
	sdDrvInit(memblk);
	sdMemBlkDestroy(memblk);
}

/***
*			[eBeB֐
***/

/*	f[^̓ǂݍ	*/
void *load_file(char *fname, long *len)
{
	GDFS gdfs;
	long fsize, nsct;
	void *dat=NULL;

	if ( (gdfs=gdFsOpen(fname, NULL)) == NULL ) {
		for (;;) {
			njPrint(NJM_LOCATION(3, 5), "can't open %s", fname);
			njWaitVSync();
		}
	}
	gdFsGetFileSize(gdfs, &fsize);
	nsct = (fsize+2047)/2048;
	if ( (dat=syMalloc(nsct*2048)) != NULL ) {
		gdFsRead(gdfs, nsct, dat);
	}
	gdFsClose(gdfs);
	if ( len != NULL )
		*len = fsize;

	return dat;
}

/*	Ԃ̕ϊ	*/
void sfcnt2time(long sf, long ncnt, long *hh, long *mm, long *ss, long *ff)
{
	register long nf = (long)((double)ncnt/(double)sf*100.0);

	*hh = nf/(60*60*100);
	*mm = nf/(60*100) - *hh*60;
	*ss = nf/100 - *hh*60*60 - *mm*60;
	*ff = nf%100;
}

/* GDt@CVXẽG[ɋN֐ */
void usr_gd_err_func(void *obj, Sint32 errcode)
{
	if (errcode == GDD_ERR_TRAYOPEND || errcode == GDD_ERR_UNITATTENT) {
		/*	CuI					*/
		ADXT_Finish();
		/*	ECȕI				*/
		sbExitSystem();
		/*	VvvCփWv			*/
		syBtExit();
 	}
 	return;
}

/* [UVSYNC荞ݓo^֐ */
static void usr_vsync_func(void)
{
	Sint32 dstat;

    /* TEhCũT[o */
    sdSysServer();
	/* GDhCȕԃ`FbN */
	dstat = gdFsGetDrvStat();
	if (dstat == GDD_DRVSTAT_OPEN || dstat == GDD_DRVSTAT_BUSY) {
		gdFsReqDrvStat();
	}
	return;
}

/***
*			TvvO
***/

/*	Ԃ̕\	*/
void adxtst_disp_stat(ADXT *adxt, long nadxt)
{
	char *ststr[6] =
		{"STOP   ", "DECINFO   ", "PREP   ", "PLAYING", "DECEND ", "PLAYEND"};
	long i, stat, sfreq, cnt;
	long hh, mm, ss, ff;

		njPrint(NJM_LOCATION(3, 3), "ADX Sample Program No.2");
		njPrint(NJM_LOCATION(3, 4), "   ( Memory Play )");
	for (i=0; i<nadxt; i++) {
		stat = ADXT_GetStat(adxt[i]);
		njPrint(NJM_LOCATION(3, 6+i*3), "ADXT %2d: Stat=%s", i, ststr[stat]);

		ADXT_GetTime(adxt[i], &cnt, &sfreq);
		sfcnt2time(sfreq,  cnt, &hh, &mm, &ss, &ff);
		njPrint(NJM_LOCATION(12, 7+i*3), "Time = %2d:%2d:%2d.%2d", hh, mm, ss, ff);
	}
}

/*	t@CĐp[N̈̑傫	*/
#define	WKSIZE		(ADXT_CALC_WORK(MAX_CH, 0, 0, MAX_SFREQ))
/*	t@CĐp ADXT [N̈	*/
char work[MAX_ADXT][WKSIZE];

/*	Tv	*/
void adxsmp(void)
{
	const NJS_PERIPHERAL* per;
	ADXT adxt[MAX_ADXT];
	void *adxdat, *acxdat;
	long i;

	/*	ACX f[^̓ǂݍ	*/
	adxdat = load_file("SAMPLE.ADX", NULL);
	/*	ACX f[^̓ǂݍ	*/
	acxdat = load_file("SMPL_MEM.ACX", NULL);
	/*	Đp ADXT nh̐	*/
	for (i=0; i<MAX_ADXT; i++) {
		if ( (adxt[i]=ADXT_Create(2, work[i], WKSIZE)) == NULL ) {
			for (;;) {
				njPrint(NJM_LOCATION(1, 27), "can't create ADXT\n");
				njWaitVSync();
			}
		}
	}

	ADXT_SetOutPan(adxt[2], 0, ADXT_PAN_LEFT);
	ADXT_SetOutPan(adxt[3], 0, ADXT_PAN_RIGHT);

	for (;;) {
		per = njGetPeripheral(NJD_PORT_A0);
		/*	Đ	*/
		if (per->press & NJD_DGT_TA)
			ADXT_StartMem(adxt[0], adxdat);
		/*	CfbNXĐ	*/
		if (per->press & NJD_DGT_TB)
			ADXT_StartMemIdx(adxt[0], acxdat, 0);
		if (per->press & NJD_DGT_TX)
			ADXT_StartMemIdx(adxt[1], acxdat, 1);
		if (per->press & NJD_DGT_TY)
			ADXT_StartMemIdx(adxt[1], acxdat, 2);
		if (per->press & NJD_DGT_KR)
			ADXT_StartMemIdx(adxt[2], acxdat, 3);
		if (per->press & NJD_DGT_KL)
			ADXT_StartMemIdx(adxt[2], acxdat, 4);
		if (per->press & NJD_DGT_KD)
			ADXT_StartMemIdx(adxt[3], acxdat, 5);
		if (per->press & NJD_DGT_KU)
			ADXT_StartMemIdx(adxt[3], acxdat, 6);
		if (per->press & NJD_DGT_ST)
			for (i=0; i<MAX_ADXT; i++) ADXT_Stop(adxt[i]);
		adxtst_disp_stat(adxt, MAX_ADXT);
		njWaitVSync();
	}
	for (i=0; i<MAX_ADXT; i++)
		ADXT_Destroy(adxt[i]);
	syFree(acxdat);
	syFree(adxdat);
}

/*	ADXCuŃG[Ƃ̃R[obN֐	*/
void userAdxErrFunc(void *obj, char *msg)
{
	/*	G[Ƃ̊֐Ăяo܂B						*/
	/*	msg ɃG[bZ[Wn܂B								*/
	/*	msǵAR5WX^Ɋi[Ă̂ŁAR5WX^̃AhX		*/
	/*	_v邱ƂɂăG[bZ[Wm邱Ƃł܂B		*/
	/*	̊֐́AV-Sync荞݂Ăяo邱Ƃ܂̂ŁA		*/
	/*	Ninjå֐͎gpȂłB									*/
	/*	܂AAvP[V[XƂ́Aɖ߂悤	*/		/*	֐ɂĂB												*/

	for (;;);		/*	[Xɂ͖								*/

}

void main(void)
{
	void *snddrv;

	/* \̏ */
    njSetBorderColor( 0x00000000 ) ;
	sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI,
										NJD_FRAMEBUFFER_MODE_RGB565, 1 );
	njInitVertexBuffer( -30000, 0, 30000, 0, 0);
    njInitPrint(NULL, 0, 0);
	njSetBackColor(0x00000000,0x00000000,0x000000FF);
	/* GDt@CVXeG[R[obN֐̓o^	*/
	gdFsEntryErrFuncAll((void *)usr_gd_err_func, NULL);

	/* TEhCȕ */
	snddrv = load_file("manatee.drv", NULL);
	sound_init(snddrv);
	/* DMA ][h	*/
	sdMemBlkSetTransferMode(SDE_MEMBLK_TRANSFER_MODE_DMA);
	njSetVSyncFunction((void (*)(void))usr_vsync_func);

	/*	Cu	*/
	ADXT_Init();
	/*	G[R[obN֐̓o^	*/
	ADXT_EntryErrFunc(userAdxErrFunc, NULL);

	for (;;)
		adxsmp();

	/*	CuI					*/
	ADXT_Finish();
	/*	ECȕI				*/
	sbExitSystem();
	/*	VvvCփWv			*/
	syBtExit();
}
