/*
 *			ADXT TvvO No.4
 *				(ADXt@CVXe)
 */

#include	<math.h>
#include	<string.h>
#include	<shinobi.h>

#include	"cri_adxf.h"
#include	"cri_adxt.h"
#include	"pat02.h"

/***
*		`
***/

/*	p[eBVhc	*/
#define	PATID		(0)
/*	p[eBV̍őt@C	*/
#define	MAX_NFILES	(256)
/*	AFSt@C (p[eBV)	*/
#define AFSFNAME	"PAT02.AFS"

/*	Đő`l	*/
#define	MAX_CH			(2)
/*	ĐőCDXg[	*/
#define	MAX_CDSTM		(1)
/*	ōTvOg	*/
#define	MAX_SFREQ		(44100)
/*	őADXFnh	*/
#define	MAX_ADXF		(5)

/***
*		TEh̏
***/

#include	"shinobi.h"
#include	"sg_sd.h"

/* TEhhCo̓]E */
Void	sound_init(Void *ptr)
{
	SDMEMBLK	memblk = NULL;

	/*	Initialize Sound library	 */
	sdLibInit(NULL, 0, 0);		/*	This api's argument is dummy now.  */

	/* 	Download and Initialize Sound driver.	 */
	/*	Create Memory block handle  */
	sdMemBlkCreate(&memblk);
	/*  Setting Memoby block handle  */
	sdMemBlkSetPrm(memblk, ptr, 0, SDD_MEMBLK_SYNC_FUNC, NULL);
	/*	Initialize Sound driver  */
	sdDrvInit(memblk);
	sdMemBlkDestroy(memblk);
}

/***
*			[eBeB֐
***/

/*	f[^̓ǂݍ	*/
void *load_file(char *fname, long *len)
{
	GDFS gdfs;
	long fsize, nsct;
	void *dat=NULL;

	if ( (gdfs=gdFsOpen(fname, NULL)) == NULL ) {
		for (;;) {
			njPrint(NJM_LOCATION(3, 5), "can't open %s", fname);
			njWaitVSync();
		}
	}
	gdFsGetFileSize(gdfs, &fsize);
	nsct = (fsize+2047)/2048;
	if ( (dat=syMalloc(nsct*2048)) != NULL ) {
		gdFsRead(gdfs, nsct, dat);
	}
	gdFsClose(gdfs);
	if ( len != NULL )
		*len = fsize;

	return dat;
}

/*	Ԃ̕ϊ	*/
void sfcnt2time(long sf, long ncnt, long *hh, long *mm, long *ss, long *ff)
{
	register long nf = (long)((double)ncnt/(double)sf*100.0);

	*hh = nf/(60*60*100);
	*mm = nf/(60*100) - *hh*60;
	*ss = nf/100 - *hh*60*60 - *mm*60;
	*ff = nf%100;
}

/* GDt@CVXẽG[ɋN֐ */
void usr_gd_err_func(void *obj, Sint32 errcode)
{
	if (errcode == GDD_ERR_TRAYOPEND || errcode == GDD_ERR_UNITATTENT) {
		/*	CuI					*/
		ADXT_Finish();
		/*	ECȕI				*/
		sbExitSystem();
		/*	VvvCփWv			*/
		syBtExit();
 	}
 	return;
}

/* [UVSYNC荞ݓo^֐ */
static void usr_vsync_func(void)
{
	Sint32 dstat;

    /* TEhCũT[o */
    sdSysServer();
	/* GDhCȕԃ`FbN */
	dstat = gdFsGetDrvStat();
	if (dstat == GDD_DRVSTAT_OPEN || dstat == GDD_DRVSTAT_BUSY) {
		gdFsReqDrvStat();
	}
	return;
}

/***
*			TvvO
***/

char data_buf[100*2048];

/*	Ԃ̕\	*/
void adxsmp_disp(ADXF *adxf, long nadxf)
{
	long i, j;
	char *ststr[5] = {"    ", "STOP", "READ", "END ", "ERR "};

	njPrint(NJM_LOCATION(3, 3), "ADX Sample Program No.4");
	njPrint(NJM_LOCATION(3, 4), "   ( ADX File system )");
	for (i=0; i<nadxf; i++) {
		njPrint(NJM_LOCATION(3+i*5, 6), "%s", ststr[ADXF_GetStat(adxf[i])]);
	}
	for (i=0; i<20; i++) {
		for (j=0; j<32; j++)
			njPrint(NJM_LOCATION(3+j, 8+i), "%c", data_buf[i*2048*5+j]);
	}
}

/*	f[^̈̃NA	*/
void adxsmp_clear_data(void)
{
	memset(data_buf, 'x', sizeof(data_buf));
}

/*	t@CĐp[N̈̑傫	*/
#define	WKSIZE		(ADXT_CALC_WORK(MAX_CH, 1, MAX_CDSTM, MAX_SFREQ))
/*	t@CĐp ADXT [N̈	*/
char work[WKSIZE];

/*	Tv	*/
void adxsmp(void)
{
	const NJS_PERIPHERAL* per;
	long i;
	ADXF adxf[MAX_ADXF];
	ADXT adxt;

	adxt = ADXT_Create(2, work, WKSIZE);
	ADXT_StartFname(adxt, "loopsmp.adx");
	adxf[0] = ADXF_OpenAfs(PATID, TEST1_BIN);
	adxf[1] = ADXF_OpenAfs(PATID, TEST2_BIN);
	adxf[2] = ADXF_OpenAfs(PATID, TEST3_BIN);
	adxf[3] = ADXF_OpenAfs(PATID, TEST4_BIN);
	adxf[4] = ADXF_OpenAfs(PATID, TEST5_BIN);

	for (;;) {
		per = njGetPeripheral(NJD_PORT_A0);
		/*	AFS t@CĐ	*/
		if (per->press & NJD_DGT_TA) {
			if ( ADXF_Tell(adxf[0]) ==  ADXF_GetFsizeSct(adxf[0]) )
				ADXF_Seek(adxf[0], 0, ADXF_SEEK_SET);
			ADXF_ReadNw32(adxf[0], 100, data_buf);
		}
		if (per->press & NJD_DGT_TB) {
			if ( ADXF_Tell(adxf[1]) ==  ADXF_GetFsizeSct(adxf[1]) )
				ADXF_Seek(adxf[1], 0, ADXF_SEEK_SET);
			ADXF_ReadNw32(adxf[1], 100, data_buf);
		}
		if (per->press & NJD_DGT_TX) {
			if ( ADXF_Tell(adxf[2]) ==  ADXF_GetFsizeSct(adxf[2]) )
				ADXF_Seek(adxf[2], 0, ADXF_SEEK_SET);
			ADXF_ReadNw32(adxf[2], 100, data_buf);
		}
		if (per->press & NJD_DGT_TY) {
			if ( ADXF_Tell(adxf[3]) ==  ADXF_GetFsizeSct(adxf[3]) )
				ADXF_Seek(adxf[3], 0, ADXF_SEEK_SET);
			ADXF_ReadNw32(adxf[3], 100, data_buf);
		}
		if (per->press & NJD_DGT_KL) {
			if ( ADXF_Tell(adxf[4]) ==  ADXF_GetFsizeSct(adxf[4]) )
				ADXF_Seek(adxf[4], 0, ADXF_SEEK_SET);
			ADXF_ReadNw32(adxf[4], 100, data_buf);
		}
		if (per->press & NJD_DGT_ST)
			adxsmp_clear_data();
		adxsmp_disp(adxf, MAX_ADXF);
		njWaitVSync();
	}
	for (i=0; i<MAX_ADXF; i++)
		ADXF_Close(adxf[i]);
	ADXT_Destroy(adxt);
}

/*	ADXCuŃG[Ƃ̃R[obN֐	*/
void userAdxErrFunc(void *obj, char *msg)
{
	/*	G[Ƃ̊֐Ăяo܂B						*/
	/*	msg ɃG[bZ[Wn܂B								*/
	/*	msǵAR5WX^Ɋi[Ă̂ŁAR5WX^̃AhX		*/
	/*	_v邱ƂɂăG[bZ[Wm邱Ƃł܂B		*/
	/*	̊֐́AV-Sync荞݂Ăяo邱Ƃ܂̂ŁA		*/
	/*	Ninjå֐͎gpȂłB									*/
	/*	܂AAvP[V[XƂ́Aɖ߂悤	*/		/*	֐ɂĂB												*/
#if 0
	for (;;);		/*	[Xɂ͖								*/
#endif
}

/*	p[eBV̈	*/
static char ptinfo[ADXF_CALC_PTINFO_SIZE(MAX_NFILES)];

void main(void)
{
	void *snddrv;

	/* \̏ */
    njSetBorderColor( 0x00000000 ) ;
	sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI,
										NJD_FRAMEBUFFER_MODE_RGB565, 1 );
	njInitVertexBuffer( -30000, 0, 30000, 0, 0);
    njInitPrint(NULL, 0, 0);
	njSetBackColor(0x00000000,0x00000000,0x000000FF);
	/* GDt@CVXeG[R[obN֐̓o^	*/
	gdFsEntryErrFuncAll((void *)usr_gd_err_func, NULL);

	/* TEhCȕ */
	snddrv = load_file("manatee.drv", NULL);
	sound_init(snddrv);
	/* DMA ][h	*/
	sdMemBlkSetTransferMode(SDE_MEMBLK_TRANSFER_MODE_DMA);
	njSetVSyncFunction((void (*)(void))usr_vsync_func);

	/*	Cu	*/
	ADXT_Init();
	/*	G[R[obN֐̓o^	*/
	ADXT_EntryErrFunc(userAdxErrFunc, NULL);

	/*	p[eBV̓ǂݍ	*/
	ADXF_LoadPartition(PATID, AFSFNAME, ptinfo, MAX_NFILES);
	adxsmp_clear_data();
	for (;;)
		adxsmp();

	/*	CuI					*/
	ADXT_Finish();
	/*	ECȕI				*/
	sbExitSystem();
	/*	VvvCփWv			*/
	syBtExit();
}
