/*
 *  Middleware Library
 *  Copyright (c) 1998 SEGA
 *  
 *		Middleware Player Sample (MPEG Sofdec & WAVE)
 *
 *  Module  : Sample Program
 *  File    : test.c
 *  Create  : 1998-06-29
 *  Modify  : 1998-10-29
 *  Version : 1.03
 *  Note    : 
 */

/***********************************************************************
 *      CN[ht@C
 ***********************************************************************/
#include <machine.h>
#include <shinobi.h>
#include <sg_mw.h>

/***********************************************************************
 *      萔}N
 ***********************************************************************/

/* fobOpɋ錾ɂ */
#define	STATIC

/*	f[^̓ǂݍ	*/
void *load_file(char *fname, long *len)
{
	GDFS gdfs;
	long fsize, nsct;
	void *dat=NULL;

	if ( (gdfs=gdFsOpen(fname, NULL)) == NULL )
		for (;;);
	gdFsGetFileSize(gdfs, &fsize);
	nsct = (fsize+2047)/2048;
	if ( (dat=syMalloc(nsct*2048)) != NULL ) {
		gdFsRead(gdfs, nsct, dat);
	}
	gdFsClose(gdfs);
	if ( len != NULL )
		*len = fsize;

	return dat;
}

#include	<stdarg.h>

/*	bZ[Wo	*/
long njPrintf(long lx, long ly, char *fmt,...)
{
    va_list args;
    static char buf[256];
    long ret, pos;

	memset(buf, 0, sizeof(buf));
    va_start(args, fmt);
    ret = vsprintf(buf, fmt, args);
    va_end(args);
    pos = NJM_LOCATION(lx, ly);
	njPrintC(pos, buf);

    return ret;
}

/* TEhhCo̓]E */
Void	SoundInit(Void *ptr)
{
	SDMEMBLK	memblk = NULL;

	/*	Initialize Sound library	 */
	sdLibInit(NULL, 0, 0);		/*	This api's argument is dummy now.  */

	/* 	Download and Initialize Sound driver.	 */
	/*	Create Memory block handle  */
	sdMemBlkCreate(&memblk);
	/*  Setting Memoby block handle  */
	sdMemBlkSetPrm(memblk, ptr, 0, SDD_MEMBLK_SYNC_FUNC, NULL);
	/*	Initialize Sound driver  */
	sdDrvInit(memblk);
	sdMemBlkDestroy(memblk);
}

/*	msec ==> Time	*/
void ms2time(long mstime, long *hh, long *mm, long *ss, long *ff)
{
	*hh = mstime / (60*60*1000);
	*mm = (mstime - *hh*60*60*1000) / (60*1000);
	*ss = (mstime - *hh*60*60*1000 - *mm*60*1000) / 1000;
	*ff = mstime % 1000;
}

/***
*			~hEFA̍Đ
***/

/* G[ */
Sint32	errcnt;
/*	\	*/
Sint32 disp_flag = 1;

/* G[ɋN֐ */
static void errFunc(void *obj, Sint32 ecode)
{
    /* G[R[h̃`FbN */
    if (ecode != MWD_PLY_ERR_OK) {
		errcnt++;
    }
}

/* GDt@CVXẽG[ɋN֐ */
void usrGdErrFunc(void *obj, Sint32 errcode)
{
	if (errcode == GDD_ERR_TRAYOPEND || errcode == GDD_ERR_UNITATTENT) {
		/*	CuI					*/
		mwPlyFinishSofdec();
		mwPlyFinishWav();
		/*	ECȕI				*/
		sbExitSystem();
		/*	VvvCփWv			*/
		syBtExit();
 	}
 	return;
}

/* [UVSYNC荞ݓo^֐ */
static void usrVsyncFunc(void)
{
	Sint32 dstat;

    /* TEhCũT[o */
    sdSysServer();
	/* GDhCȕԃ`FbN */
	dstat = gdFsGetDrvStat();
	if (dstat == GDD_DRVSTAT_OPEN || dstat == GDD_DRVSTAT_BUSY) {
		gdFsReqDrvStat();
	}
	return;
}

/*	~hEFA̍Đ	*/
void play_main(MWPLY ply, char *fname)
{
    MWE_PLY_STAT			stat;
	const NJS_PERIPHERAL	*per;

	mwPlyEntryErrFunc((void *)errFunc, &ply);
	/* ĐJn */
	mwPlyStartFname(ply, fname);
	while (1) {
		njWaitVSync();
		mwPlyStartFrame();
		per = njGetPeripheral(NJD_PORT_A0);
		if (per->press & NJD_DGT_TA) {
			if ( disp_flag == 1 )
				disp_flag = 0;
			else
				disp_flag = 1;
		}
		if (per->press & NJD_DGT_TB)
			break;
	    /* nhԂ̎擾 */
	    stat = mwPlyGetStat(ply);
	    if ((stat == MWE_PLY_STAT_PLAYEND) || (stat == MWE_PLY_STAT_ERROR))
			break;
		if ( disp_flag == 1 ) {
			long time, tunit, hh, mm, ss, ff, time_ms;
			float timef;

			mwPlyGetTime(ply, &time, &tunit);
			timef = (float)time/(float)tunit*1000;
			time_ms = (long)timef;
			ms2time(time_ms, &hh, &mm, &ss, &ff);
			ff = ff*30/1000;
			njPrintf(3, 3, "File: %s  Time:%02d:%02d:%02d.%02d",
												fname, hh, mm, ss, ff);
		}
		mwPlyExecServer();
	}
	mwPlyStop(ply);		/* Đ~ */
	njWaitVSync();		/*	pbh̏Ԏ擾̂	*/
	mwPlyDestroy(ply);	/* nh */
}

/***
*			MPEG Sofdec ̍Đ
***/

/*	̍Đ	*/
void play_sfd(char *fname)
{
    MWPLY					ply;
    MWS_PLY_CPRM_SFD		cprm;

	/* nh̐ */
    cprm.ftype  = MWD_PLY_FTYPE_SFD;
    cprm.dtype  = MWD_PLY_DTYPE_AUTO;
    cprm.work   = syMalloc(MWD_SFD_SIZE_WORK);
    cprm.wksize = MWD_SFD_SIZE_WORK;
	ply = mwPlyCreateSofdec(&cprm);
	if (ply == NULL)
		for (;;) ;
	play_main(ply, fname);
	syFree(cprm.work);
}

/***
*			WAVE t@C̍Đ
***/

#define WAV_BUF_SIZE	MWD_PLY_ALLOC_SJBUF(MWD_PLY_ALLOC_LIMIT)
char play_wav_buf[WAV_BUF_SIZE];

/*	WAVt@C̍Đ	*/
void play_wav(char *fname)
{
    MWPLY					ply;
	MWS_PLY_CPRM_WAV		cprm;

	/* nh̐ */
	cprm.buf  = syMalloc(WAV_BUF_SIZE);
	cprm.size = WAV_BUF_SIZE;
	ply = mwPlyCreateWav(&cprm);
	if (ply == NULL)
		for (;;) ;
	play_main(ply, fname);
	syFree(cprm.buf);
}

/***
*			C
***/

void main(void)
{
	void 					*snddrv;
	const NJS_PERIPHERAL	*per;

	/*	~hEFÂ߂̃VXe (sbInitSystem̑Oɒu)@*/
	mwPlyPreInitSofdec();
    njSetBorderColor(0x00000000);
    sbInitSystem(NJD_RESOLUTION_640x480_NTSCI,NJD_FRAMEBUFFER_MODE_ARGB8888,1);
    njInitVertexBuffer(-500000, 0, 10000, 0, 0);
	njInitPrint(NULL, 0, NJD_TEXFMT_ARGB_8888);
    njPrintSize(12);

	/*	~hEFACu@*/
    mwPlyInitSofdec(NULL);
	mwPlyInitWav(MWD_PLY_MN_EXEC_VSYNC);

	/*	TEhCȕ */
	snddrv = load_file("manatee.drv", NULL);
	SoundInit(snddrv);
	njSetVSyncFunction(usrVsyncFunc);
	sdMemBlkSetTransferMode(SDE_MEMBLK_TRANSFER_MODE_DMA);

	/* GDt@CVXeG[R[obN֐̓o^	*/
	gdFsEntryErrFuncAll((void *)usrGdErrFunc, NULL);

	for (;;) {
		per = njGetPeripheral(NJD_PORT_A0);
		njPrintf(3, 3, "Middleware Player Sample No.1 (MPEG Sofdec & WAVE)");
		njPrintf(5, 6, "A: Play MPEG Sofdec");
		njPrintf(5, 8, "X: Play WAVE");
		njPrintf(5, 10, "B: Stop");
		if (per->press & NJD_DGT_TA)
			play_sfd("SAMPLE.SFD");
		if (per->press & NJD_DGT_TX)
			play_wav("SAMPLE.WAV");
		njWaitVSync();
	}

	/* CuI */
	mwPlyFinishSofdec();
	mwPlyFinishWav();
	/*	ECȕI				*/
	sbExitSystem();
	/*	VvvCփWv			*/
	syBtExit();
}
