#ifndef _BACKUP_H_
#define _BACKUP_H_

#include <shinobi.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/******** J[h\ *******************************************/
typedef struct {
	Uint16 Ready;               /* J[h}EgĂ邩      */
	Uint16 IsFormat;            /* tH[}bgĂ邩ǂ          */
	Uint32 LastError;           /* ŌɔG[R[h              */
	Uint32 ProgressCount;       /* o߃JEg                        */
	Uint32 ProgressMax;         /* o߃JEgő                    */
	Uint32 Operation;           /* ̃Iy[VR[h            */
	BUS_DISKINFO DiskInfo;      /* hCu                            */
	Uint32 Connect;             /*  J[hڑĂ邩         */
	void* Work;                 /* [NAhX                          */
	Uint32 WorkSize;            /* [NTCY                            */
	Uint32 Capacity;            /* J[h̗eʃtO(BUD_CAPACITY)  */
} BACKUPINFO;


void BupInit(void);
void BupExit(void);
const BACKUPINFO* BupGetInfo(Sint32 drive);
const char* BupGetErrorString(Sint32 err);
const char* BupGetOperationString(Sint32 op);
Sint32 BupLoad(Sint32 drive, const char* fname, void* buf);
Sint32 BupSave(Sint32 drive, const char* fname, void* buf, Sint32 nblock);
Sint32 BupDelete(Sint32 drive, const char* fname);
void BupMount(Sint32 drive);
void BupUnmount(Sint32 drive);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _BACKUP_H_ */

/******************************* end of file *******************************/
