/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XvCgAj[V\
  ҏW F 98-04-20 Jn
              98-04-23 ꖇ̃eNX`[4
                       EFCguď\
              98-06-18 SET5Ή
              98-07-13 pauseʁAĕt΍
              98-08-20 _obt@TCYύX
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>


#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 1000
#define SPRITE_Z -1500.F
/*^Cv{bNXgpI*/
#define OLD_PAD pdSetMode(PDD_MODE_TYPE_A);


NJS_TEXNAME texname[1] ;
NJS_SPRITE sprite;
NJS_TEXLIST texlist = {texname, 1};
NJS_MATRIX *gMatrix;
NJS_VERTEX_BUF *gVbuf;
NJS_VIEW view;
NJS_LIGHT light;
NJS_TEXANIM anim[] = {
                       {256, 256, 64, 64, 0, 0, 127, 127, 0, 0},
                       {256, 256, 64, 64, 0, 128, 127, 255, 0, 0},
                       {256, 256, 64, 64, 128, 0, 255, 127, 0, 0},
                       {256, 256, 64, 64, 128, 128, 255, 255, 0, 0}
                        };
NJS_TEXMEMLIST  texmemlist[1];
NJS_FOG_TABLE fog;

void main(void)
{
	njSetBorderColor( 0x00000000 );
        njUserInit();
        while (njUserMain() == NJD_USER_CONTINUE) {
                njWaitVSync();
        }
        njUserExit();
}
/*----------------------------------------------------------------------
           
----------------------------------------------------------------------*/
void njUserInit(void)
{
    /* VXȅ */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /*matrixvertexobt@̊m*/
    gMatrix = (NJS_MATRIX *)syMalloc(sizeof (NJS_MATRIX) * MAX_MATRIX_DEPTH);
    gVbuf = (NJS_VERTEX_BUF *)syMalloc(sizeof (NJS_VERTEX_BUF) * MAX_VERTEXES);
    /* wiF̐ݒ */
    njSetBackColor(ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 192));
    /* eNX`obt@̊m */
    njInitTextureBuffer((Sint8 *)gVbuf,0x800*10);
    /* _i[obt@̊m */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bN̏ */
    njInitMatrix(gMatrix, MAX_MATRIX_DEPTH, 1);
    /* 3DVXȅ */
    njInit3D(gVbuf, MAX_VERTEXES);
    /* ̏ */
    njCreateLight(&light, NJD_DIR_LIGHT);
    /* r[̏ */
    njInitView(&view);
    /* r[̐ݒ */
    njSetView(&view);
/*--------------------------------------
         eNX`[ݒ
----------------------------------------*/
     njInitTexture( texmemlist, 1 );
    /*ꖇ̃eNX`[ݒ*/
    njSetTextureName(&texname[0],"sprite.pvr", 0, NJD_TEXATTR_TYPE_FILE|NJD_TEXATTR_GLOBALINDEX);
    /*eNX`[[h*/
    njLoadTexture( &texlist);
    /*eNX`[̓o^*/
    njSetTexture(&texlist);
    /*geNX`[NoD*/
    njSetTextureNum(0);

/*---------------------------------
    FOG
----------------------------------*/
    njSetFogColor(0xff0000c0);
    njSetFogTable(fog);
}


/*----------------------------------------------------------------------
         C
----------------------------------------------------------------------*/
Sint32 njUserMain(void)
{

    static int animCt = 0;/*Aj[VEFCgpJE^[*/
    static PDS_PERIPHERAL *input;
    static Bool pause = FALSE;  /*flag for pausing*/
    static Uint32 print_col = 0x11c00000;

    input = pdGetPeripheral(PDD_PORT_A0);   /*get key state*/
    /*checking key*/
    if (input->press & PDD_DGT_ST){
        pause = !pause;
    }
    if(pause) {     /*F̍XV*/
        njPrintSize(20);
        njPrintColor(print_col);
        njPrintC(NJM_LOCATION(6, 5), "PAUSE");
        if (print_col < 0xffc0c0c0) {
            print_col += 0x03000000;
        }
        /*pause̓tHO𔭐*/
        njGenerateFogTable2(fog, -50.F);
        njSetFogTable(fog);
        njFogEnable();
    } else {        /*size/F߂*/
        njPrintSize(8);
        njPrintColor(0xffc0c0c0);
        print_col = 0x11c00000;
        /*tHOʃIt*/
        njFogDisable();
        /* Tv̕\ */
        njPrintC(NJM_LOCATION(6, 5), "Ninja Sample SPRITE ANIMATION");

    }
    /* }gNXX^bÑNA */
    njClearMatrix();
    /*XvCgݒ*/
    sprite.tlist = &texlist;
    sprite.sx = 0.5f;
    sprite.sy = 0.5f;
    sprite.p.x = 140.0f;
    sprite.p.y = 100.0f;
    /*Ajp^[*/
    switch (animCt){
    case 0:
        sprite.tanim = &anim[0];
        break;
    case 30:
        sprite.tanim = &anim[1];
        break;
    case 60:
        sprite.tanim = &anim[2];
        break;
    case 90:
        sprite.tanim = &anim[3];
        break;
    case 120:
        sprite.tanim = &anim[0];
        animCt = 0;
        break;
    default:
        break;
    }
    njDrawSprite2D(&sprite, 0, SPRITE_Z, NJD_SPRITE_ANGLE);
    if (!pause) {   /*|[Y̓Aj[VXVȂ*/
        animCt++;
    }
    return NJD_USER_CONTINUE;
}

/*----------------------------------------------------------------------
         I
----------------------------------------------------------------------*/
void njUserExit(void)
{
    /*eNX`[̊J*/
	njExitPrint();
    njExitTexture();
    /*matrixvbuf̃NA*/
    syFree(gMatrix);
    syFree(gVbuf);
    /* VXȅI */
    sbExitSystem();
}











































