
/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XvCgilp`|Sj]\
  ҏW F 98-04-23 XvCgpɂPpvrݒ
                       XvCg\̂̉]pXV
              98-06-19 SET5Ή
              98-07-14 pause@\(|S̕\)A
                       ĕth~΍
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
        njUserInit();
        while (njUserMain() == NJD_USER_CONTINUE) {
                njWaitVSync();
        }
        njUserExit();
}

#define MAX_MATRIX_DEPTH 100
#define MAX_VERTEXES 1000
#define SPRITE_Z -150.F
#define SPRITE_ANG 0x0050
#define MAX_POLYGON_VTX 10

/*C^[tF[XpI*/
#define OLD_PAD pdSetMode(PDD_MODE_TYPE_A);

NJS_TEXNAME texname[1] ;
NJS_SPRITE sprite;
NJS_TEXLIST texlist = {texname, 1};
static NJS_MATRIX *matrix;
static NJS_VERTEX_BUF *vbuf;
static NJS_POLYGON_VTX *poly;
NJS_VIEW view;
NJS_LIGHT light;
NJS_TEXANIM anim[] = {{256, 256, 128, 128, 0, 0, 255, 255, 0, 0}};
NJS_TEXMEMLIST  texmemlist[1];


/*----------------------------------------------------------------------
           
----------------------------------------------------------------------*/
void njUserInit(void)
{
    /* VXȅ */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /*matrixvertexobt@̊m*/
    matrix = (NJS_MATRIX *)syMalloc(sizeof (NJS_MATRIX) * MAX_MATRIX_DEPTH);
    vbuf = (NJS_VERTEX_BUF *)syMalloc(sizeof (NJS_VERTEX_BUF) * MAX_VERTEXES);
    poly = (NJS_POLYGON_VTX *)syMalloc(sizeof (NJS_POLYGON_VTX) * MAX_POLYGON_VTX);
    /* wiF̐ݒ */
    njSetBackColor(ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 0), ARGB(0, 0, 0, 255));
    /* eNX`obt@̊m */
    njInitTextureBuffer((Sint8 *)vbuf,0x800*10);
    /* _i[obt@̊m */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bN̏ */
    njInitMatrix(matrix, MAX_MATRIX_DEPTH, 1);
    /* 3DVXȅ */
    njInit3D(vbuf, MAX_VERTEXES);
    /* ̏ */
    njCreateLight(&light, NJD_DIR_LIGHT);
    /* r[̏ */
    njInitView(&view);
    /* r[̐ݒ */
    njSetView(&view);
/*--------------------------------------
@         eNX`[ݒ
----------------------------------------*/
     njInitTexture( texmemlist, 1 );
    /*ꖇ̃eNX`[ݒ*/
    njSetTextureName(&texname[0],"sprite.pvr",0,NJD_TEXATTR_TYPE_FILE|NJD_TEXATTR_GLOBALINDEX);
    /*eNX`[[h*/
    njLoadTexture( &texlist);
    /*eNX`[̓o^*/
    njSetTexture(&texlist);
    /*geNX`[NoD*/
    njSetTextureNum(0);
    /*XvCg̐ݒ*/
    sprite.tlist = &texlist;
    sprite.sx = 0.4f;
    sprite.sy = 0.4f;
    sprite.p.x = 160.0f;
    sprite.p.y = 120.0f;
    sprite.tanim = anim;
    /*]p̏*/
    sprite.ang = 0x0000;

/*---------------------------------
    POLYGON
----------------------------------*/
    poly[0].x = 0.F;
    poly[0].y = 0.F;
    poly[0].z = 5.0F;
    poly[0].col = 0x77000000;
    poly[1].x = 0.F;
    poly[1].y = 480.F;
    poly[1].z = 5.0F;
    poly[1].col = 0x77000000;
    poly[2].x = 640.F;
    poly[2].y = 0.F;
    poly[2].z = 5.0F;
    poly[2].col = 0x77000000;
    poly[3].x = 640.F;
    poly[3].y = 480.F;
    poly[3].z = 5.0F;
    poly[3].col = 0x77000000;

}

/*----------------------------------------------------------------------
         C
----------------------------------------------------------------------*/
Sint32 njUserMain(void)
{
    static PDS_PERIPHERAL *input;
    static Bool pause = FALSE;
    static Uint32 print_col = 0x11c00000;
    input = pdGetPeripheral(PDD_PORT_A0);   /*get key state*/
    /*checking key*/
    if (input->press & PDD_DGT_ST){
        pause = !pause;
    }
    /* }gNXX^bÑNA */
    njClearMatrix();
    /*XvCg̕`*/
    njDrawSprite2D(&sprite, 0, SPRITE_Z, NJD_SPRITE_ANGLE);
    /* Tv̕\ */
    njPrintSize(8);
    njPrintColor(0xffc0c0c0);
    njPrintC(NJM_LOCATION(6, 5), "Ninja Sample ROT SPRITE 1");
    if(pause) {             /*F/TCY̍XV*/
        njPrintSize(20);
        njPrintColor(print_col);
        njPrintC(NJM_LOCATION(5, 4), "PAUSE");
        if (print_col < 0xffc0c0c0) {
            print_col += 0x03000000;
        }
        /*|S̕`*/
        njDrawPolygon(poly, 4, TRUE);
    } else{
        /*pausełȂȂ]pXV*/
        sprite.ang += SPRITE_ANG;
    }
    return NJD_USER_CONTINUE;
}

/*----------------------------------------------------------------------
         I
----------------------------------------------------------------------*/
void njUserExit(void)
{
    /*eNX`[̊J*/
	njExitPrint();
    njExitTexture();
    /*matrixvbufApolẙJ*/
    syFree(matrix);
    syFree(vbuf);
    syFree(poly);
    /* VXȅI */
    sbExitSystem();
}




































