/*==============================================
    Ninja Sample
    
    COPYRIGHT (C) SEGA ENTERSRISES,LTD.

    `NftbgVF[fBOɕϊ

    1998.10.2
================================================*/
#include <shinobi.h>
#include <njdef.h>
#include "flatconv.h"

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 10000
static NJS_MATRIX *Matrix;
static NJS_VERTEX_BUF *VertexBuffer;

static NJS_CAMERA c1;
const PDS_PERIPHERAL* per;

/* IuWFNgf[^ǂݍݗp */
static Sint8 *w_buff;
static NJS_CNK_OBJECT *obj;

/* tbgVF[fBOp */
#define	VNUM	111		/* ϊ̒_ */
static void *vlst;

/*----------------------------------------------------------------------
           
----------------------------------------------------------------------*/
void njUserInit(void)
{
	/* t@Cǂݍݗp */
	GDFS fid;
	Sint32 sn;
	Uint32 rtype, rpos = 0;
	/* tbgVF[fBOւ̃Ro[gp */
	NJS_CNK_MODEL *mp;

    /* VXȅ */
    sbInitSystem(NJD_RESOLUTION_640x480_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* ʂ̃AXyNgݒ */
    njSetAspect( 1.0F, 0.91F );
    /* 蓖 */
    Matrix = syMalloc(sizeof(NJS_MATRIX) * MAX_MATRIX_DEPTH);
    VertexBuffer   = syMalloc(sizeof(NJS_VERTEX_BUF) * MAX_VERTEXES);
    /* wiF̐ݒ */
    njSetBackColor(ARGB(0, 0, 0, 192), ARGB(0, 0, 0, 192), ARGB(0, 0, 0, 192));
    /* _i[obt@̊m */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bN̏ */
    njInitMatrix(Matrix, MAX_MATRIX_DEPTH, 1);
    /* 3DVXȅ */
    njInit3D(VertexBuffer, MAX_VERTEXES);
    njControl3D( NJD_CONTROL_3D_MODEL_CLIP);

	/* J̏ */
	njInitCamera(&c1);
	njSetCamera(&c1);

	/* F̐ݒ */
	njPrintColor(0xFFC0C0C0);
	/* \ʒu̒ */
	njAdjustDisplay(0,8);

	njClipZ(-1.f, -20000.f);

	njPrintSize(16);

    /* Cg̐ݒ */
	njCnkSetEasyLight( 0.f, 0.f, 1.0f );
	njCnkSetEasyLightIntensity( 1.0f, 0.0f );
	njCnkSetEasyLightColor( 1.0f, 1.0f, 1.0f );

	/* IuWFNgt@C̃[h */
	fid = gdFsOpen("sphere1.nj", NULL);
	gdFsGetFileSctSize(fid, &sn);
	w_buff = (Sint8 *)syMalloc(sn*2048+8);
	gdFsRead(fid, sn, w_buff);
	gdFsClose(fid);
	obj = (NJS_CNK_OBJECT *)njReadBinary(w_buff, &rpos, &rtype);

	/* tbgVF[fBOɂȂ悤ɖ@f[^Ro[g */
	mp = obj->model;
	/* `Nwb_̕ƁAϊ̒_i[ł̈mۂB */
    vlst = syMalloc(sizeof(Sint32)*2 + sizeof(NJS_VERTEX_CHUNK) * VNUM );
	njCnkFlatConvert(mp, (void *)vlst, 0.0001f);
}

/*----------------------------------------------------------------------
         C
----------------------------------------------------------------------*/
Sint32 njUserMain(void)
{
static Float oz = -25.f;
static Angle rx, ry, rz;

	njPrintC(NJM_LOCATION(4,4), "CHUNK FLAT SHADING SAMPLE");

	njPushMatrix(NULL);
	    njTranslate(NULL, 0.F, 0.0F, oz);

		ry += NJM_DEG_ANG(1);
		rx += NJM_DEG_ANG(1);
		rz += NJM_DEG_ANG(1);
	    njRotateXYZ(NULL, rx, ry, rz);

	    njCnkEasyDrawObject(obj);
	njPopMatrix(1);
    return NJD_USER_CONTINUE;
}

/*----------------------------------------------------------------------
         I
----------------------------------------------------------------------*/
void njUserExit(void)
{
    /* ̊J */
	syFree(vlst);
	syFree(obj);
	syFree(w_buff);
    syFree(Matrix);
    syFree(VertexBuffer);
    /* VXȅI */
    njExitPrint();
    sbExitSystem();
}
