/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F }`Cg
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

/* O`̃ff[^ƃeNX`f[^ */
#define	OBJ		 object_tea_Teapot1E_Teapot1E
#define	TEXLIST	texlist_tea_Teapot1E
extern NJS_CNK_OBJECT   OBJ[];
extern NJS_TEXLIST  TEXLIST;

/* }gNX֘A */
#define MATRIX_DEPTH 16
#define VERTEX_MAX   5000

/*   J */
static NJS_CAMERA  camera;
static NJS_LIGHT g_Light;

/* ]f[^ */
static Angle g_XAng = NJM_DEG_ANG(0.0F);
static Angle g_YAng = NJM_DEG_ANG(0.0F);
static Angle g_ZAng = NJM_DEG_ANG(0.0F);

/* eNX`֘A */
#define TEXTURE_NUM 1
static NJS_TEXMEMLIST g_Texture[TEXTURE_NUM]; /*eNX`f[^ێ̈*/

static NJS_VERTEX_BUF *g_VBuf;
static NJS_MATRIX *g_Matrix;  /* }gNXX^bN */

/* [J֐vg^Cv錾 */
void SimpleLightOnOff(void);
void InitCnkSimpleMultiLight(void);
void ExecCnkSimpleMultiLight(void);
void EasyLightOnOff(void);
void InitCnkEasyMultiLight(void);
void ExecCnkEasyMultiLight(void);

/**********************************************************************
    njUserInit --- NinjaVXe֐
**********************************************************************/
void njUserInit(void)
{
    /* VXȅ */
	sbInitSystem( NJD_RESOLUTION_640x480_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1 );
   /* ʂ̃AXyNgݒ */
    njSetAspect( 1.0F, 1.0F );
    /* ̊蓖 */
    g_Matrix = (NJS_MATRIX *)syMalloc(sizeof(NJS_MATRIX) * MATRIX_DEPTH);
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);
    njInitTextureBuffer( ( Sint8 * )g_VBuf, 0x800*10 );
    /* wiF̐ݒ */
	njSetBackColor(0x00000000,0x00000000,0x000000FF);
    /* _i[obt@̊m */
    njInitVertexBuffer(80000, 0, 80000, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bN̏ */
    njInitMatrix(g_Matrix, MATRIX_DEPTH, 1);
    /* _Zpobt@̏ */
    njInit3D( g_VBuf, VERTEX_MAX);
    /* J̏ */
    njInitCamera(&camera);
    njSetCamera(&camera);

    /* eNX`̃[hƃZbgAbv */
    njInitTexture(g_Texture, TEXTURE_NUM);  /* eNX`̗̈m */
    njLoadTexture(&TEXLIST);  /* eNX`Xg̃f[^̃[h */
    njSetTexture(&TEXLIST);   /* eNX`XgJgɃZbg */

    /* NbsOʂ̐ݒ */
    njClipZ( -1.0f, -500.f );

    /* eLXg̐ݒ */
	njPrintSize(16);
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));

	njSetBorderColor(0x00000000);

	/* njCnkSimpleMulti ̃Cgݒ */
	InitCnkSimpleMultiLight();

	/* njCnkEasyMulti ̃Cgݒ */
	InitCnkEasyMultiLight();
}

#define LTNUM	10
#define RANGE	10
Sint32 _num = 0;
static char *_name[LTNUM]= {
	"ALL", "OFF", "DIR", "PT1", "PT2", "PT3", "P12", "P13", "P23", "P123",
};
static int _lt_1[LTNUM]={1,0,1,0,0,0,0,0,0,0};
static int _lt_2[LTNUM]={1,0,0,1,0,0,1,1,0,1};
static int _lt_3[LTNUM]={1,0,0,0,1,0,1,0,1,1};
static int _lt_4[LTNUM]={1,0,0,0,0,1,0,1,1,1};

Sint32	xx,yy,zz = 0;
NJS_PERIPHERAL *per;

Sint32 njUserMain(void)
{
static Sint32 mode = 0;
static	Sint32 _stop = 1;

	per = njGetPeripheral(NJD_PORT_A0);

	/* Cĝnm^nee */
	if( per->press & NJD_DGT_TA ) {
		_num++;
		_num %= LTNUM;
		if (mode == 0) SimpleLightOnOff();
		else EasyLightOnOff();
	}
	njPrint(NJM_LOCATION(2,5), "LIGHT : %s", _name[_num]);

	/* Simple  Easy ̐؂ւ */
	if (per->press & NJD_DGT_TX) {
		if (!(mode = ~mode)) SimpleLightOnOff();
		else EasyLightOnOff();
	}
	if (mode == 0) {
		ExecCnkSimpleMultiLight();
	} else {
		ExecCnkEasyMultiLight();
	}

	/* f̉]nm^nee */
	if(per->press & NJD_DGT_ST){
		_stop ^= 1;
	}
	if (_stop) {
		xx += 257;
		yy += 179;
		zz += 193;
	}
	njPrintC(NJM_LOCATION(2,23), "    A:CHANGE LIGHT");
	njPrintC(NJM_LOCATION(2,24), "    X:CHANGE DRAW");
	njPrintC(NJM_LOCATION(2,25), "START:PAUSE");

    return NJD_USER_CONTINUE;
}

/**********************************************************************

    njUserExit --- NinjaVXeI֐

**********************************************************************/

void njUserExit(void)
{
    /* ̊J */
    syFree(g_Matrix);
    syFree(g_VBuf);
	njExitPrint();
    njExitTexture();
    /* VXȅI܂ ŌɕKĂяoĂ */
    sbExitSystem();
}


/*----------------------------------------------
     njCnkSimpleMulti ̃CgݒƏ{
 --------------------------------------------- */
void InitCnkSimpleMultiLight(void)
{
	/* `NCǧ̐ݒ              *
	 * iŌݒL[Ȃ̂    *
	 *   ƃCg̎ނ͈ȉ̂悤      *
	 *   ֘A܂B                     j   *
	 *                                         *
	 * 1:sP                            *
	 * 2:sP+_Q                   *
	 * 3:sP+_Q+_R          *
	 * 4:sP+_Q+_R+_S *
	 *                                         */

	njCnkSetSimpleMultiLight(4);

	/* `NCg̕siԖڂ̌jݒ */
	njCnkSetSimpleMultiLightVector(0.f, 0.f, -1.f);

	/* `NCg̓_ʒuݒ */
	/* QԖڂ̌i_j̐ݒ */
	njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_2, 0.f, 0.f, -12.f);
	/* RԖڂ̌i_j̐ݒ */
	njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_3, 0.f, 0.f, -12.f);
	/* SԖڂ̌i_j̐ݒ */
	njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_4, 0.f, 0.f, -12.f);

	/* `NCg̓_͈́ijݒ */
	njCnkSetSimpleMultiLightRange(NJD_CNK_SIMPLE_MULTILIGHT_2, 6.f, 40.f);
	njCnkSetSimpleMultiLightRange(NJD_CNK_SIMPLE_MULTILIGHT_3, 6.f, 40.f);
	njCnkSetSimpleMultiLightRange(NJD_CNK_SIMPLE_MULTILIGHT_4, 6.f, 40.f);

	/* `NCg̃ArGgFݒ */
	njCnkSetSimpleMultiAmbient(0.1f, 0.1f, 0.1f);

	/* `NCǧFݒ */
	njCnkSetSimpleMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_1, 0.5f, 0.5f, 0.5f);
	njCnkSetSimpleMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_2, 1.f, 0.0f, 0.0f);
	njCnkSetSimpleMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_3, 0.0f, 1.f, 0.0f);
	njCnkSetSimpleMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_4, 0.0f, 0.0f, 1.f);
}

/*
     Cĝnm^nee
*/
void SimpleLightOnOff(void)
{
	/* `NCĝnmEneeݒ               *
	 * inmFPAneeFOj                       *
	 *  NJD_CNK_SIMPLE_MULTILIGHT_ALLtOgp *
	 *  ƂŐݒ肳ꂽׂẴCg؂芷܂*/
 
	if (!_num) {
		njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_ALL, 1);
	}
	if (_num==1) {
		njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_ALL, 0);
	} else {
		njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_1, _lt_1[_num]);
		njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_2, _lt_2[_num]);
		njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_3, _lt_3[_num]);
		njCnkSetSimpleMultiLightSwitch(NJD_CNK_SIMPLE_MULTILIGHT_4, _lt_4[_num]);
	}
}

/*
	{
*/
void ExecCnkSimpleMultiLight(void)
{
	njPushMatrix(NULL);
	{
		NJS_POINT3 p1,p2,p3;
		static int a1,a2,a3;

		a1 += 0x100;
		a2 += 0x200;
		a3 += 0x300;

		p1.x = RANGE * njCos(a1);
		p1.y = RANGE * njSin(a1);
		p1.z = -12.f;

		p2.x = RANGE * njCos(a2);
		p2.y = 0.f;
		p2.z = -12.f + RANGE * njSin(a2);

		p3.x = 0.f;
		p3.y = RANGE * njSin(a3);
		p3.z = -12.f + RANGE * njCos(a3);

		njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_2, p1.x, p1.y, p1.z);
		njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_3, p2.x, p2.y, p2.z);
		njCnkSetSimpleMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_4, p3.x, p3.y, p3.z);
		
		/* `NCg̕Eʒu̔f              *
		 * ̊֐́A{IɃr[EJ̐ݒ  *
		 * ݒ肵ĂB                            *
		 * Oɐݒ肳ꂽׂẴCg̈ʒuE  *
		 * 𔽉f܂B                          */
	 
		njCnkSetSimpleMultiLightMatrices();
	}

	njTranslate( NULL, 0.f, 0.f, -12.f );
	njRotateXYZ( NULL, xx,yy,zz );
	njCnkSimpleMultiDrawObject( OBJ );
	njPopMatrix(1);
	njPrintC(NJM_LOCATION(2,3), "Simple Multi");
}

/*----------------------------------------------
    njCnkEasyMulti ̃CgݒƏ{
 --------------------------------------------- */
void InitCnkEasyMultiLight(void)
{
	/* `NCǧ̐ݒ              *
	 * iŌݒL[Ȃ̂    *
	 *   ƃCg̎ނ͈ȉ̂悤      *
	 *   ֘A܂B                     j   *
	 *                                         *
	 * 1:sP                            *
	 * 2:sP+_Q                   *
	 * 3:sP+_Q+_R          *
	 * 4:sP+_Q+_R+_S *
	 *                                         */

	njCnkSetEasyMultiLight(4);

	/* `NCg̕siԖڂ̌jݒ */
	njCnkSetEasyMultiLightVector(0.f, 0.f, -1.f);

	/* `NCg̓_ʒuݒ */
	/* QԖڂ̌i_j̐ݒ */
	njCnkSetEasyMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_2, 0.f, 0.f, -12.f);
	/* RԖڂ̌i_j̐ݒ */
	njCnkSetEasyMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_3, 0.f, 0.f, -12.f);
	/* SԖڂ̌i_j̐ݒ */
	njCnkSetEasyMultiLightPoint(NJD_CNK_SIMPLE_MULTILIGHT_4, 0.f, 0.f, -12.f);

	/* `NCg̓_͈́ijݒ */
	njCnkSetEasyMultiLightRange(NJD_CNK_SIMPLE_MULTILIGHT_2, 6.f, 40.f);
	njCnkSetEasyMultiLightRange(NJD_CNK_SIMPLE_MULTILIGHT_3, 6.f, 40.f);
	njCnkSetEasyMultiLightRange(NJD_CNK_SIMPLE_MULTILIGHT_4, 6.f, 40.f);

	/* `NCg̃ArGgFݒ */
	njCnkSetSimpleMultiAmbient(0.1f, 0.1f, 0.1f);

	/* `NCǧFݒ */
	njCnkSetEasyMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_1, 0.5f, 0.5f, 0.5f);
	njCnkSetEasyMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_2, 1.f, 0.0f, 0.0f);
	njCnkSetEasyMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_3, 0.0f, 1.f, 0.0f);
	njCnkSetEasyMultiLightColor(NJD_CNK_SIMPLE_MULTILIGHT_4, 0.0f, 0.0f, 1.f);
}

/*
     Cĝnm^nee
*/
void EasyLightOnOff(void)
{
	/* `NCĝnmEneeݒ               *
	 * inmFPAneeFOj                       *
	 *  NJD_CNK_SIMPLE_MULTILIGHT_ALLtOgp *
	 *  ƂŐݒ肳ꂽׂẴCg؂芷܂*/
 
	if (!_num) {
		njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_ALL, 1);
	}
	if (_num==1) {
		njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_ALL, 0);
	} else {
		njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_1, _lt_1[_num]);
		njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_2, _lt_2[_num]);
		njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_3, _lt_3[_num]);
		njCnkSetEasyMultiLightSwitch(NJD_CNK_EASY_MULTILIGHT_4, _lt_4[_num]);
	}
}

/*
	{
*/
void ExecCnkEasyMultiLight(void)
{
	njPushMatrix(NULL);
	{
		NJS_POINT3 p1,p2,p3;
		static int a1,a2,a3;
		
		a1 += 0x100;
		a2 += 0x200;
		a3 += 0x300;
		
		p1.x = RANGE * njCos(a1);
		p1.y = RANGE * njSin(a1);
		p1.z = -12.f;
	
		p2.x = RANGE * njCos(a2);
		p2.y = 0.f;
		p2.z = -12.f + RANGE * njSin(a2);
	
		p3.x = 0.f;
		p3.y = RANGE * njSin(a3);
		p3.z = -12.f + RANGE * njCos(a3);
	
		njCnkSetEasyMultiLightPoint(NJD_CNK_EASY_MULTILIGHT_2, p1.x, p1.y, p1.z);
		njCnkSetEasyMultiLightPoint(NJD_CNK_EASY_MULTILIGHT_3, p2.x, p2.y, p2.z);
		njCnkSetEasyMultiLightPoint(NJD_CNK_EASY_MULTILIGHT_4, p3.x, p3.y, p3.z);
	
		/* `NCg̕Eʒu̔f              *
		 * ̊֐́A{IɃr[EJ̐ݒ  *
		 * ݒ肵ĂB                            *
		 * Oɐݒ肳ꂽׂẴCg̈ʒuE  *
		 * 𔽉f܂B                          */

		njCnkSetEasyMultiLightMatrices();
	}
	njTranslate( NULL, 0.f, 0.f, -12.f );
	njRotateXYZ( NULL, xx,yy,zz );
	njCnkEasyMultiDrawObject( OBJ );
	njPopMatrix(1);
	njPrintC(NJM_LOCATION(2,3), "Easy Multi");
}
