
/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD

  ^Cg F }gNX̃vbV|bv
  ҏW F 98-05-08 쐬Jn
              98-06-19 SET5Ή
              98-07-08 C0ĂtɑΉi|[Yǉj
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 10000

extern NJS_CNK_OBJECT object_cube_root[];

static NJS_MATRIX *Matrix;
static NJS_VERTEX_BUF *VBuf;
static NJS_VIEW View;
static NJS_LIGHT Light;

/* O[v̐ݒ */
#define GROUP_NUM 4
/* P̃O[v̐̕ݒ */
#define OBJECT_NUM 6
/* Ŝ̉]xݒ */
#define ROTATION_SPEED_ALL 1.0F
/* O[v̉]x͈̔͂ݒ */
#define MAX_SPEED_GROUP 4.0F
/* ̂̉]x͈̔͂ݒ */
#define MAX_SPEED_OBJECT 8.0F

/* ]Ԃ\ */
typedef struct {
    Angle ang; /* px */
    Angle rsp; /* ]̑ */
} RotateState;

static RotateState Group[GROUP_NUM]; /* O[v̉] */
static RotateState Object[GROUP_NUM][OBJECT_NUM]; /* ̂̉] */

PDS_PERIPHERAL* Per;

void PauseMode(void);

/************************************************************
  ֐
************************************************************/
void njUserInit(void)
{
    /* VXe */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* ʂ̃AXyNg␳ */
    njSetAspect( 1.0F, 0.45F );
    /* obt@pAP[g */
    Matrix = syMalloc(sizeof(NJS_MATRIX) * MAX_MATRIX_DEPTH);
    VBuf = syMalloc(sizeof(NJS_VERTEX_BUF) * MAX_VERTEXES);

    /* obNOEhJ[ݒ */
    njSetBackColor(ARGB(0, 0, 0, 64), ARGB(0, 0, 0, 64), ARGB(0, 64, 0, 0));
    /* _f[^o^pobt@AP[giP̒_US^SoCgj */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bNiPCgZp̃}gNXgpj */
    njInitMatrix(Matrix, MAX_MATRIX_DEPTH, 1);
    /* RcVXȅif`̂߂̃[Nobt@j */
    njInit3D(VBuf, MAX_VERTEXES);
    /* ̎ނ߃CgVɐݒuiso^j
      iʒu0,0,0ji0,0,-1j */
    njCreateLight(&Light, NJD_SPEC_DIR);
    /* r[̏iʒu0,0,0ji0,0,-1jiXOxj */
    njInitView(&View);
    /* [U̗pӂr[Jgr[Ɏw */
    njSetView(&View);
    /* fobO̐F */
    njPrintColor(ARGB(255, 150, 150, 150));

    /* ̎ݒ */
    njRandomSeed(0);

    {
        int grp; /* O[vɑ΂郋[vJE^ */
        int obj; /* ̂ɑ΂郋[vJE^ */

        /* O[vƂ̏pxƉ]̑ݒ */
        for (grp = 0; grp < GROUP_NUM; grp++) {
            RotateState *grpp = &Group[grp];
            grpp->ang = NJM_DEG_ANG(0.0F);
            grpp->rsp = (Angle)(NJM_DEG_ANG(1.0F) * (njRandom() *
                MAX_SPEED_GROUP * 2.0F - MAX_SPEED_GROUP));
        }

        /* ̂Ƃ̏pxƉ]̑ݒ */
        for (grp = 0; grp < GROUP_NUM; grp++) {
            for (obj = 0; obj < OBJECT_NUM; obj++) {
                RotateState *objp = &Object[grp][obj];
                objp->ang = NJM_DEG_ANG(0.0F);
                objp->rsp = (Angle)(NJM_DEG_ANG(1.0F) * (njRandom() *
                    MAX_SPEED_OBJECT * 2.0F - MAX_SPEED_OBJECT));
            }
        }
    }

    /* Ŝ̉]̒S */
    njTranslate(NULL, 0.0F, -5.0F, -30.0F);
}

/************************************************************
  s郁C
************************************************************/
Sint32 njUserMain(void)
{
    static Angle angAll = NJM_DEG_ANG(0.0F); /* Ŝ̉]p*/

    static Bool pauseMode = FALSE;

    /* Tv̕\ */
    njPrintC(NJM_LOCATION(4, 2), "Ninja Sample MATRIX STACK");
    njPrintC(NJM_LOCATION(4, 4), "Press Start Button To Pause");

    /* ytF`FbN */
    Per = pdGetPeripheral(PDD_PORT_A0);
    if (Per->press & PDD_DGT_ST) { /* X^[g{^ꂽ */
        pauseMode = !pauseMode;
    }

    /* |[Yʂ */
    if (pauseMode == TRUE) {
        njLightOff(&Light);
        PauseMode();
    }
    else {
        njLightOn(&Light);
    }

    { /* IuWFNg\ */
        int grp; /* O[vɑ΂郋[vJE^ */
        int obj; /* ̂ɑ΂郋[vJE^ */

        for (grp = 0; grp < GROUP_NUM; grp++) {
            njPushMatrix(NULL);
            /* O[v̉]̒S */
            njRotateY(NULL, angAll + (Angle)(NJM_DEG_ANG(1.0F) *
                grp * (360.0F / GROUP_NUM)));
            njTranslate(NULL, 0.0F, 0.0F, 10.0F);

            for (obj = 0; obj < OBJECT_NUM; obj++) {
                njPushMatrix(NULL);
                /* ̂̉]̒S */
                njRotateY(NULL, Group[grp].ang + (Angle)(NJM_DEG_ANG(1.0F) *
                    obj * (360.0F / OBJECT_NUM)));
                njTranslate(NULL, 0.0F, 0.0F, 4.0F);
                njRotateY(NULL, Object[grp][obj].ang);
                /* ̂\ */
                njCnkDrawObject(object_cube_root);
                njPopMatrix(1);
            }
            njPopMatrix(1);
        }
    }

    if (pauseMode == FALSE) {
        /* Ŝ̉]pXV */
        angAll += NJM_DEG_ANG(ROTATION_SPEED_ALL);

        {
            int grp; /* O[vɑ΂郋[vJE^ */
            int obj; /* ̂ɑ΂郋[vJE^ */

            /* O[v̉]pXV */
            for (grp = 0; grp < GROUP_NUM; grp++) {
                RotateState *grpp = &Group[grp];
                grpp->ang += grpp->rsp;
            }
            /* ̂̉]pXV */
            for (grp = 0; grp < GROUP_NUM; grp++) {
                for (obj = 0; obj < OBJECT_NUM; obj++) {
                    RotateState *objp = &Object[grp][obj];
                    objp->ang += objp->rsp;
                }
            }
        }
    }

    return NJD_USER_CONTINUE;
}

/************************************************************
  sIɌĂяoI
************************************************************/
void njUserExit(void)
{
	njExitPrint();
    /*  */
    syFree(Matrix);
    syFree(VBuf);

    /* VXȅI */
    sbExitSystem();
}

/************************************************************
  |[YɌĂяo鏈
************************************************************/
void PauseMode(void)
{
    static Sint16 interval = 0;
    static Bool display = TRUE;

    interval++;
    if (interval >= 30) {
        display = !display;
        interval = 0;
    }
    if (display == TRUE) {
        njPrintSize(32);
        njPrintC(NJM_LOCATION(7, 6),"PAUSE!");
        njPrintSize(8);
    }
}
