/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XyL
  ҏW F 98-05-01 Jn
              98-06-19 SET5Ή
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 1000

#define SPECULAR_CYCLE 500
#define SPECULAR_CHANGE_SPEED NJM_DEG_ANG(1.0F)

#define SCREEN_SAVE_TIME 30

extern NJS_OBJECT object__sphere3_sphere3[];

static NJS_MATRIX *Matrix;
static NJS_VERTEX_BUF *VertexBuffer;

static NJS_VIEW View;
static NJS_LIGHT SpecularLight;
static NJS_LIGHT AmbientLight;

/*----------------------------------------------------------------------
           
----------------------------------------------------------------------*/
void njUserInit(void)
{
    /* VXȅ */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* ʂ̃AXyNgݒ */
    njSetAspect( 1.0F, 0.45F );
    /* 蓖 */
    Matrix = syMalloc(sizeof(NJS_MATRIX) * MAX_MATRIX_DEPTH);
    VertexBuffer   = syMalloc(sizeof(NJS_VERTEX_BUF) * MAX_VERTEXES);
    /* wiF̐ݒ */
    njSetBackColor(ARGB(0, 192, 0, 0), ARGB(0, 0, 192, 0), ARGB(0, 0, 0, 192));
    /* _i[obt@̊m */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bN̏ */
    njInitMatrix(Matrix, MAX_MATRIX_DEPTH, 1);
    /* 3DVXȅ */
    njInit3D(VertexBuffer, MAX_VERTEXES);
    njControl3D( NJD_CONTROL_3D_CONSTANT_ATTR );
    /* XyL̐ݒ */
    njCreateLight(&SpecularLight, NJD_SPEC_POINT);
    njSetLightIntensity(&SpecularLight, 0.0F, 0.0F, 0.0F);
    njSetLightColor(&SpecularLight, 1.0F, 1.0F, 1.0F);
    njTranslateLight(&SpecularLight, 10.0F, 10.0F, -77.0F);
    njSetLightAngle(&SpecularLight, NJM_DEG_ANG(30.0F), NJM_DEG_ANG(60.0F));
    /* ̐ݒ */
    njCreateLight(&AmbientLight, NJD_LAMBERT_DIR);
    njSetLightIntensity(&AmbientLight, 0.0F, 0.4F, 0.4F);
    njSetLightColor(&AmbientLight, 1.0F, 1.0F, 1.0F);
    /* r[̏ */
    njInitView(&View);
    /* r[̐ݒ */
    njSetView(&View);
	/* F̐ݒ */
	njPrintColor(0xFFC0C0C0);
}

/*----------------------------------------------------------------------
         C
----------------------------------------------------------------------*/
Sint32 njUserMain(void)
{
    static Angle rotateAng = NJM_DEG_ANG(0.0F);/* ]pxpϐ */
    static int counter = 0;/* XyL\ԐݒpJE^ */
	static Bool pause = FALSE; 	/* |[YĂ邩 */
	static int pause_counter = 0;
	static PDS_PERIPHERAL *key;

	/* |[Y̔ */
	key = pdGetPeripheral(PDD_PORT_A0);

	if (key->press & PDD_DGT_ST) {
	    if (pause == FALSE) {
		    njSetBackColor(0x00000000, 0x00000000, 0x00000000);
		    pause = TRUE;
		} else {
		    njSetBackColor(0x00C00000, 0x0000C000, 0x000000C0);
		    pause = FALSE;
		}
	}

	if (pause == FALSE) {
	    counter++;
	}
    if (counter == SPECULAR_CYCLE) {
        counter = 0;/* JE^̃Zbg */
    }
    /* VF[fBO̐ݒ */
    njSetConstantAttr( 0xFFFFFFFF, NJD_FLAG_USE_FLAT);

    /* XyL̐؂ւ */
    if (counter < SPECULAR_CYCLE / 2) {
        njPrintC(NJM_LOCATION(7, 7),"SPECULAR ON");
        njSetLightIntensity(&SpecularLight, 20.0F, 0.0F, 0.0F);
    } else {
        njPrintC(NJM_LOCATION(7, 7),"SPECULAR OFF");
        njSetLightIntensity(&SpecularLight, 0.0F, 0.0F, 0.0F);
    }

    /* Tv̕\ */
    njPrintC(NJM_LOCATION(23, 4), "Ninja Sample SPECULAR");
    /* }gbNXX^bÑNA */
    njClearMatrix();

    /* ʂ̕\ */
    njTranslate(NULL, 0.0F, 0.0F, -100.0F);
    /* X,Y,Z ̏Ԃɉ] */
    njRotateXYZ(NULL, rotateAng, rotateAng, rotateAng);
    /* IuWFNg̕` */
	if (pause == FALSE) {
	   njDrawObject(object__sphere3_sphere3 );
	} else {
	    pause_counter++;
	    if (pause_counter > SCREEN_SAVE_TIME) {
		    njDrawObject(object__sphere3_sphere3 );
			njPrintC(NJM_LOCATION(30, 5), "PAUSE");
		}
		if (pause_counter == SCREEN_SAVE_TIME * 2) {
				pause_counter = 0;
		}
	}

    /* X,Y,Z ւ̉]p̍XV */
	if (pause == FALSE) {
	    rotateAng += SPECULAR_CHANGE_SPEED;
	}
    return NJD_USER_CONTINUE;
}

/*----------------------------------------------------------------------
         I
----------------------------------------------------------------------*/
void njUserExit(void)
{
	njExitPrint();
    /* ̊J */
    syFree(Matrix);
    syFree(VertexBuffer);
    /* VXȅI */
    sbExitSystem();
}
