/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F |SfɃeNX`𒣂
  ҏW F 98-04-28 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[oZNV */

/* O`̃ff[^ƃeNX`f[^ */
extern NJS_OBJECT   object_cube[];
extern NJS_TEXLIST  texlist_cube;

/* }gNX֘A */

#define MATRIX_DEPTH 16
#define VERTEX_MAX   1048

/* static NJS_MATRIX *g_Matrix;  * }gNXX^bN */
/* static NJS_VERTEX_BUF *g_VBuf;  * Zp_obt@ */

/*   _ */

static NJS_VIEW  g_View;
static NJS_LIGHT g_Light;

/* ]f[^ */

static Angle g_XAng = NJM_DEG_ANG(0.0F);
static Angle g_YAng = NJM_DEG_ANG(0.0F);
static Angle g_ZAng = NJM_DEG_ANG(0.0F);

/* eNX`f[^ */

#define TEXTURE_NUM 1

static NJS_TEXMEMLIST g_Texture[TEXTURE_NUM]; /*eNX`f[^ێ̈*/

static NJS_VERTEX_BUF *g_VBuf;
static NJS_MATRIX *g_Matrix;  /* }gNXX^bN */

/* |[YtO */
Bool g_bPause = FALSE;
/* |[Y֐ */
void ActivePhase(void);
/* ANeBu֐ */
void PausePhase(void);

/**********************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐

**********************************************************************/

void njUserInit(void)
{
    /* VXȅ */
    sbInitSystem(NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
   /* ʂ̃AXyNgݒ */
    njSetAspect( 1.0F, 0.45F );
    /* ̊蓖 */
    g_Matrix = (NJS_MATRIX *)syMalloc(sizeof(NJS_MATRIX) * MATRIX_DEPTH);
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);
    njInitTextureBuffer( ( Sint8 * )g_VBuf, 0x800*10 );
    /* wiF̐ݒ */
    njSetBackColor(ARGB(0xff, 0xc0, 0, 0), 
                        ARGB(0xff, 0, 0xc0, 0), ARGB(0xff, 0, 0, 0xc0));
    /* _i[obt@̊m */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* }gNXX^bN̏ */
    njInitMatrix(g_Matrix, MATRIX_DEPTH, 1);
    /* Zp_obt@̏ */
    njInit3D( g_VBuf, VERTEX_MAX);
    /* ̏ */
    njCreateLight(&g_Light, NJD_LAMBERT_DIR);
    /* r[̏ */
    njInitView(&g_View);
    /* r[̐ݒ */
    njSetView(&g_View);

    /* eNX`̃[hƃZbgAbv */
    njInitTexture(g_Texture, TEXTURE_NUM);  /* eNX`̗̈m */
    njLoadTexture(&texlist_cube);  /* eNX`Xg̃f[^̃[h */
    njSetTexture(&texlist_cube);   /* eNX`XgJgɃZbg */

    /* NbsOʂ̐ݒ */
    njClipZ( -1.0f, -500.f );
    /* eLXg̃J[̐ݒ */
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/**********************************************************************

    njUserMain --- NinjaVXeC֐

**********************************************************************/

Sint32 njUserMain(void)
{
    NJS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    per = njGetPeripheral(NJD_PORT_A0);    

    /* {^ꂽǂ`FbN */
    if (per->press & NJD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	/* |[YԂɂď؂ւ */
	if (!g_bPause) {
		ActivePhase();
	} else {
		PausePhase();
	}

    /* fobO̕\ */
    njPrintC(NJM_LOCATION(23, 4), "Ninja Sample TEXTURE CUBE");

    return NJD_USER_CONTINUE;
}


/**********************************************************************

    ActivePhase --- ANeBu֐

**********************************************************************/

void ActivePhase(void)
{
    /* }gNXX^bÑNA */
    njClearMatrix();
    /* sړ */
    njTranslate(NULL, 0.0F, 0.0F, -10.0F);
    /* X,Y,Z ̏Ԃɉ] */
    njRotateXYZ(NULL, g_XAng, g_YAng, g_ZAng);
    /* IuWFNg̕` */
    njDrawObject(object_cube);
    /* X,Y,Z ւ̉]p̍XV */
    g_XAng += NJM_DEG_ANG(1.0F);
    g_YAng += NJM_DEG_ANG(1.0F);
    g_ZAng += NJM_DEG_ANG(1.0F);
}


/**********************************************************************

    PausePhase --- |[Y֐

**********************************************************************/

void PausePhase(void)
{
    NJS_POINT2COL pc;
    NJS_POINT2    p[4];
    NJS_COLOR     col[4];
    Uint8  alpha;
	static Angle ang = NJM_DEG_ANG(0.0F);
	
    /* }gNXX^bÑNA */
    njClearMatrix();
    /* sړ */
    njTranslate(NULL, 0.0F, 0.0F, -10.0F);
    /* X,Y,Z ̏Ԃɉ] */
    njRotateXYZ(NULL, g_XAng, g_YAng, g_ZAng);
    /* IuWFNg̕` */
    njDrawObject(object_cube);

    /* Z[o[pXvCg̐ݒ */
    
    /* At@l̎Zo */
    ang += NJM_DEG_ANG(2.0F);
    alpha = (Uint8)(njSin(ang) * 64 + 192);
    
    pc.p   = p;
    pc.col = col;
    pc.tex = NULL;
    pc.num = 4;
    
    p[0].x = 0;
    p[0].y = 0;
    col[0].argb.a = alpha;
	col[0].argb.r = 0;
	col[0].argb.g = 0;
	col[0].argb.b = 0;

    p[1].x = 0;
    p[1].y = 480;
    col[1].argb.a = alpha;
	col[1].argb.r = 0;
	col[1].argb.g = 0;
	col[1].argb.b = 0;

    p[2].x = 640;
    p[2].y = 480;
    col[2].argb.a = alpha;
	col[2].argb.r = 0;
	col[2].argb.g = 0;
	col[2].argb.b = 0;

    p[3].x = 640;
    p[3].y = 0;
    col[3].argb.a = alpha;
	col[3].argb.r = 0;
	col[3].argb.g = 0;
	col[3].argb.b = 0;

    /* Z[o[p|S̕` */
    njDrawPolygon2D(&pc, 4, -2.0F, NJD_FILL | NJD_TRANSPARENT);

	/* |[Ŷm点 */
    njPrintC(NJM_LOCATION(38, 30), "PAUSE");
}


/**********************************************************************

    njUserExit --- NinjaVXeI֐

**********************************************************************/

void njUserExit(void)
{
    /* ̊J */
    syFree(g_Matrix);
    syFree(g_VBuf);
	njExitPrint();
    njExitTexture();
    /* VXȅI܂ ŌɕKĂяoĂ */
    sbExitSystem();
}
