#include "shinobi.h"
#include "onmempcm.h"

void main() {
  mpHn *hn;
  Sint32 port[]  = { 0, 1 };
  char   *name[] = { "SAMPLE_L.P08", "SAMPLE_R.P08" };

  njSetBorderColor( 0x00000000 );
  sbInitSystem( NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1 );
  njInitVertexBuffer( 0x50000, 0, 0x50000, 0, 0 );
  njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

  SoundInitialize( "MANATEE.DRV", "STREAM.MLT" );

  mpInit();

  hn = mpOpen( name, 2 );
  if ( hn == NULL ) PrgStop();
  mpSetPort( hn, port, 2 );
  mpSetPrm( hn, 44100, 8 );


  mpPlay( hn, 0 );
  mpSetLoopStart( hn, 824000 );
  mpSetLoop( hn, true );

  while( -1 ) {
    njPrint( NJM_LOCATION( 3, 3 ), "On Memory PCM Stream Sample 1" );
    SoundLibVer( 4, 5 );
    SoundDrvVer( 4, 6 );
    SoundDrvStat( 4, 7 );
    mpTask();
    sdSysServer();
    njWaitVSync();
  }
}
